SystemOrganization addCategory: #'CodeTalk-Attributes'!
SystemOrganization addCategory: #'CodeTalk-Commands'!
SystemOrganization addCategory: #'CodeTalk-Database'!
SystemOrganization addCategory: #'CodeTalk-Kernel'!
SystemOrganization addCategory: #'CodeTalk-Models'!
SystemOrganization addCategory: #'CodeTalk-Morphs'!
SystemOrganization addCategory: #'CodeTalk-Nodes'!
SystemOrganization addCategory: #'CodeTalk-Panels'!
SystemOrganization addCategory: #'CodeTalk-Tests'!

!NewParagraph methodsFor: '*codetalk' stamp: 'bs 12/15/2009 12:07'!
selectionStart
	^ selectionStart! !

!NewParagraph methodsFor: '*codetalk' stamp: 'bs 12/15/2009 12:07'!
selectionStop
	^ selectionStop! !

TextLink subclass: #CtMethodLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Attributes'!

!CtMethodLink class methodsFor: 'services' stamp: 'mt 6/11/2009 11:02'!
addMethodLinksInto: aText
	"Parse the message and add links to the methods mentioned. This method will modify the attributes of the given text object."

	| rx s links strm |
	rx := '([A-Z]\w*)(\sclass)?>>#?(\w[\w:]*)' asRegex.
	s := aText asString.
	strm := s readStream.
	links := OrderedCollection new.
	
	[rx searchStream: strm]
		whileTrue: [
			links add: {
				rx subBeginning: 2.
				rx subEnd: 4.
				'{1}{2} {3}' format: {
					rx subexpression: 2.
					rx subexpression: 3.
					rx subexpression: 4}}].

	links do: [:link |
		aText
			addAttribute: (CtMethodLink new classAndMethod: link third)
			from: link first + 1
			to: link second].
		
	^ aText! !

!CtMethodLink methodsFor: 'action' stamp: 'bs 10/18/2009 16:16'!
actOnClickFor: aTextMorph

	[OBCodeBrowser defaultBrowserClass
		openOnClass: self theClass
		selector: self selector.
		World displayWorldSafely]
		on: Error
		do: [:e | Transcript show: '[CodeTalk] Method browsing not possible.'; cr].
	^ true! !

!CtMethodLink methodsFor: 'scanning' stamp: 'mt 7/2/2009 21:43'!
emphasizeScanner: scanner

	(self theClass notNil and: [self theClass selectors includes: self selector])
		ifTrue: [super emphasizeScanner: scanner]
		ifFalse: [scanner textColor: Color red]! !

!CtMethodLink methodsFor: 'accessing' stamp: 'mt 6/4/2009 16:31'!
selector

	^ (classAndMethod findTokens: Character space) last asSymbol! !

!CtMethodLink methodsFor: 'accessing' stamp: 'mt 6/4/2009 16:32'!
theClass 

	| c |
	c := Smalltalk at: self theClassName asSymbol ifAbsent: [^nil].
	self theClassIsMeta ifTrue: [^c classSide].
	^c! !

!CtMethodLink methodsFor: 'accessing' stamp: 'mt 6/4/2009 16:31'!
theClassIsMeta

	^ (classAndMethod findTokens: Character space) second = 'class'! !

!CtMethodLink methodsFor: 'accessing' stamp: 'mt 6/4/2009 16:26'!
theClassName

	^ (classAndMethod findTokens: Character space) first! !

!OBMorphBuilder methodsFor: '*codetalk' stamp: 'mt 5/27/2009 10:06'!
insertMorph: aMorph

	current ifNotNil: 
			[current addMorphBack: aMorph.
			self current: aMorph do: []].
	^ aMorph! !

!OBMorphBuilder methodsFor: '*codetalk' stamp: 'mt 3/19/2010 10:24:21.479'!
textarea: aDefinitionPanel 
	"CodeTalk: Store the pluggable textmorph in the definition panel for later access."
	
	| morph |
	morph := self textMorphClass  
		on: aDefinitionPanel
		text: #text
		accept: #accept:notifying:
		readSelection: #selection
		menu: #menu:shifted:.
	morph
		font: Preferences standardCodeFont;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	current isNil ifFalse: [ current addMorphBack: morph ].
	
	aDefinitionPanel contentMorph: morph.
	
	^ self 
		current: morph
		do: []! !

!OBMethodVersion methodsFor: '*codetalk-override' stamp: 'mt 5/3/2009 09:39'!
source

	| file |
	file := sources at: (sources fileIndexFromSourcePointer: pointer).
	file position: (sources filePositionFromSourcePointer: pointer).
	^ file nextChunkText makeSelectorBold! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/1/2009 17:52'!
ctCommentAddContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAGkSURBVDjLrZJPKINhHMd3UsrJ
TcpBDi6UC+3ookQ5OOBAaCh2cFQ40GqTzURTihI54DRp8dqBg3BQw5BtNmxe/4flT9re5+v3
vJvF2l6Kp749Pe/7fj7P7/09jwqA6i9R/ZugVr+cSZmlvFOgEIGSl0xgnVt3IRyRoDSWtn1c
4qakxQW0yKBEJMbw+MpwHWIQnxgCDwxnQQbvHYP7RoLnJirvntrkkuKvghytZU1+eUWg+Mjg
J/j0nuEkBh9dSTgQo4KB+R0uqEgquCD4PBiDbxlc11HYSfBuILUg/gu8fB/t6rmVcEzw4aWE
fYIdAS6IyILe6S0uUCdtIpd8Hbwah1+SxQlNTE91jJHPI5tcPoiLrBsL6BxrQOtQFep0pc/l
XYU9P14kkngugy/onxlF30ITlpwWOEQB5tV21JgLUNKRZVSCTeM2J6/kuV5fFrbuD8N6OCJX
Y7S3wGxv44K3VHAuxUvR8HVldxFszolvvVncs3DB7+67Wpv9Nig0Qy80yrB+pVG5gsTQh7pq
Yz5Mgkbemc98rdiDJBIDJcTLjs0G/vwDCw/6dFwBuzsAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/1/2009 17:53'!
ctCommentAddIcon
	^ Icons
			at: #'ctCommentAdd'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctCommentAddContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/28/2009 20:12'!
ctCommentContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAEvSURBVDjLY/j//z8DJZiBagZE
tO8QAuKlQPwTiP/jwbuAWAWbARtXHrz1//efv//xgS0n74MMuQ3EbHADgBweIP7z99+//x++
/fv/8tO//88+/vv/5P2//w/f/ft/782//7df/f1/5xXE8OoFx0GGmCEbIJcz9QBY8gVQ47MP
//4/Bmp+8Pbf/7tQzddf/P1/9RnEgM5VZ0EGeGM14ClQ86N3UM2v//2/9RKi+QpQ88UnuA2A
ewHk/PtAW++8/vv/JlDzted//18Gar7wBGTAH7ABtYtOgAywxBqIIEOQAcg1Fx7/BRuMFoic
uKLxDyzK5u64Cjfo/ecfYD5Q/DLWaMSGgQrvPH/3FabxOxDXEp0SgYp7Z267AtL4BYgLSUrK
QA1KQHwPiFPolxcGzAAA94sPIr7iagsAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 6/6/2009 13:27'!
ctCommentGoContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAlFJREFUeNqMU0toE1EUPTMJ2oQaJcZPaVpiKxUTjHEjBe3C
ReyiGwXxsxKKoIggiAsX7U5UEBEVXCl0URFBsitWKo2/GolU22ipbVPbNGlTwYakTpLp/J53
JhqGaFrvcLnvzZtz7pnz3uMYYzDHhd7WvKRIdklT7D2dsSLWCL7yhahIcLt2Q5TlwpH7Htta
BNzFR21M0yR6FEiKgnpnC+93H0R0dhCjqfcaEW58fTkjVCOwKpqEoO80rzINqqZCA8NCLok9
7gMQpCI/PPcq57/KO2NdWu6fBLpkHZxYmoJMKhRNhqzKWF75iUBDGwS5wEdn3mVP3Xhuxg1Q
nn98pT1OBCIUVcE2RyOBVYMsnZuDs3Y7PiaHML44gdDZYfjqAmV0X3Q22Ds48YxIfdaCIrKe
yE2QC2SgzDW7vGhtOowPibcYmY/hzrEwNtR4MbPE6BcZOCLo2O9BZHxx53Q6F7CGzn0zdoLY
Gl2OmkTkewc43oaxha+4ezwM96ZdpAzQCFyqJRUO+zq9bLFWmlKUGMKTL/HkzCTqHDuoK4zO
KsPvcYWJpnHmx7Kofu4SLKlskTrZqCMrg/4QcCgdPEGUDUz5IJGj+l73PX0TJ9k2eDZzaHbx
aNnKo3Y9B1UFKeLgr7foJmJqPhun70c481EmH5xU7lGeoLTo74L7GtDZ7jXWs8IKQkPTGPiU
/ELTo/o2QidYLU9e74+nM3n2sH+M0bhI2W1e5yovkzlI0a1De92XwqOpPE27qePtv+5CNQIC
N1F5QXmNgA+qXqbVFPxP/BJgAHnqT8NmxeLpAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 6/6/2009 13:27'!
ctCommentGoIcon

	^ Icons
			at: #'ctCommentGo'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctCommentGoContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/28/2009 20:12'!
ctCommentIcon

	^ Icons
			at: #'ctComment'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctCommentContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/1/2009 17:51'!
ctCommentsContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAG/SURBVDjLjZK9T8JQFMVZTUyc
3IyJg4mDi87+GyYu6qB/gcZdFxkkJM66qJMGSNRBxDzigJMRQ1jQ4EcQ+SgVKB+FtuL13EdJ
xNDq8Ev7Xu85797T51nwhqeAH5w6cAxWwDgReX7jwYfdaCIraroptB7NLlVQrOoiGEsL1G06
GZyxuILicsMUH3VTlOqGKNUMUdTacj+j1Nng0NGAT2WxYosK1bbIVVoiW27J9V8G57WWKVSc
zMV5iK+Tudv1vVh5yXdlLQN+os4AFZss2Ob82CCgQmhYHSnmkzf2b6rIhTAaaT2aXZALIRdC
LgRtkA1WfYG4iKcVYX52JIs7EYvFmJ8wGiEXQi6EXAhdyn2MxQaPcg68zIETTvzyLsPzWnwq
ixVbhFwI3RFykes+A9vkIBKX4jCoIxdCLrI4/0OcUXXK4/1dbbDBS088xGGCCzAJCsiF2lan
T8xdKNhHXvRarLFBqmcwCrbAhL32+kP3lHguETKRsNlbqUFPeY2OoikW62DNM+jf2ibzQNN0
g5ALC75AGiT59oIReQ+cDGyTB+TC4jaYGXiRXMTD3AFogVmnOjeDMRAC025duo7wH74BwZ8J
lHrTPLcAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/1/2009 17:54'!
ctCommentsIcon
	^ Icons
			at: #'ctComments'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctCommentsContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/1/2009 17:52'!
ctCrossContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAIhSURBVDjLlZPrThNRFIWJicmJ
z6BWiYbIkYDEG0JbBiitDQgm0PuFXqSAtKXtpE2hNuoPTXwSnwtExd6w0pl2OtPlrphKLSXh
x07OZM769qy19wwAGLhM1ddC184+d18QMzoq3lfsD3LZ7Y3XbE5DL6Atzuyilc5Ciyd7IHVf
gNcDYTQ2tvDr5crn6uLSvX+Av2Lk36FFpSVENDe3OxDZu8apO5rROJDLo30+Nlvj5RnTlVNA
Ks1aCVFr7b4BPn6Cls21AWgEQlz2+Dl1h7IdA+i97A/geP65WhbmrnZZ0GIJpr6OqZqYAd5/
gJpKox4Mg7pD2YoC2b0/54rJQuJZdm6Izcgma4TW1WZ0h+y8BfbyJMwBmSxkjw+VObNanp5h
/adwGhaTXF4NWbLj9gEONyCmUZmd10pGgf1/vwcgOT3tUQE0DdicwIod2EmSbwsKE1P8QoDk
cHPJ5YESjgBJkYQpIEZ2KEB51Y6y3ojvY+P8XEDN7uKS0w0ltA7QGCWHCxSWWpwyaCeLy0Bk
A7UXyyg8fIzDoWHeBaDN4tQdSvAVdU1Aok+nsNTipIEVnkywo/FHatVkBoIhnFisOBoZxcGt
Qd4B0GYJNZsDSiAEadUBCkstPtN3Avs2Msa+Dt9XfxoFSNYF/Bh9gP0bOqHLAm2WUF1YQskw
rVFYPWkf3h1iXwbvqGfFPSGW9Eah8HSS9fuZDnS32f71m8KFY7xs/QZyu6TH2+2+FAAAAABJ
RU5ErkJggg=='! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/1/2009 17:54'!
ctCrossIcon
	^ Icons
			at: #'ctCross'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctCrossContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/1/2009 17:52'!
ctDeleteContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAJdSURBVDjLpZP7S1NhGMf9W7Yf
ogSJboSEUVCY8zJ31trcps6zTI9bLGJpjp1hmkGNxVz4Q6ildtXKXzJNbJRaRmrXoeWx8tJO
TWptnrNryre5YCYuI3rh+8vL+/m8PA/PkwIg5X+y5mJWrxfOUBXm91QZM6UluUmthntHqplx
Uml2lciF6wrmdHriI0Wx3xw2hAediLwZRWRkCPzdDswaSvGqkGCfq8VEUsEyPF1O8Qu3O7A0
9RbRvjuIttsRbT6HHzebsDjcB4/JgFFlNv9MnkmsEszodIIY7Oaut2OJcSF68Qx8dgv8tmqE
L1gQaaARtp5A+N4NzB0lMXxon/uxbI8gIYjB9HytGYuusfiPIQcN71kjgnW6VeFOkgh3XcHL
vAwMSDPohOADdYQJdF1FtLMZPmslvhZJk2ahkgRvq4HHUoWHRDqTEDDl2mDkfheiDgt8pw34
0/EocuClCuFvboQzb0cwIZgki4KhzlaE6w0InipbVzBfqoK/qRH94i0rgokSFeO11iBkp8Ed
V8cfJo0yD75aE2ZNRvSJ0lZKcBXLaUYmQrCzDT6tDN5SyRqYlWeDLZAg0H4JQ+Jt6M3atNLE
10VSwQsN4Z6r0CBwqzXesHmV+BeoyAUri8EyMfi2FowXS5dhd7doo2DVII0V5BAjigP89GEV
Atda8b2ehodU4rNaAW+dGfzlFkyo89GTlcrHYCLpKD+V7yeeHNzLjkp24Uu1Ed6G8/F8qjqG
Rzlbl2H2dzjpMg1KdwsHxOlmJ7GTeZC/nesXbeZ6c9OYnuxUc3fmBuFft/Ff8xMd0s65SXIb
/gAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/1/2009 17:54'!
ctDeleteIcon
	^ Icons
			at: #'ctDelete'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctDeleteContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/3/2009 14:11'!
ctMagnifierContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAH5SURBVDjLpZK/a5NhEMe/748k
RqypmqQQgz/oUPUPECpCoEVwyNStIA6COFR33boIjg6mg4uL0k0EO1RFISKImkHQxlbQRAsx
0dgKJm/e53nunnOwViR5leJnuZs+973jHBHB/+D/ah7X2LXWloilyMw5YgtD3CDiBWN4Zno8
bQcJHBFBucauZfsolZDCru0OfFcAAUISrLZDfPzSKxuiibOT+T6JCwDMtrQzYQvZHQ5Cw2h3
GK0OI9AWBzJJZFOxgtJUGpTABQAiLu5OOviuGIEWkBUwC7pasNZj7N2ThNJUjBQY4pznAoEW
sBWwxU+JFXSVRTzmQWvKRR5RG4KVGMgKrAVYflexAAugDCEygdbUCI2F7zobk7FZY76DIDQg
rT9HCwwt1FsBhhIu4p4D3kiS8B0MJz28ftfGSPfl8MPLxbGBAqVpptbslJc+fEPMA7JDPrIp
H3FX8LzaROdrE5O51jalgid3Lh4b6/sDALh6971riErGcFET58gwDPGndG9JT6ReHcwfPorG
ygu8rdxvGxMeP3XtzcofgigWZ0/EtQ7n0/sOTe0/Mo7V5WeoVu61z1yvZzZX+BsnZx9opYLp
evXp7eXKIrL5UWit0n0r/Isb50bjRGreiyWmgs76lfM31y5tSQAAc6czHjONXLi13thygih+
AEq4N6GqMsuhAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/3/2009 14:11'!
ctMagnifierIcon
	^ Icons
			at: #'ctMagnifier'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctMagnifierContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 3/18/2010 18:08:07'!
ctMarkGreenContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAV9JREFUeNqM088rBGEcx/FnxiQr8rstByQOcnKhRBuxV1cX
F3+Vk5urAzkI5eKmhIste5Ef0aJltNYu4/3oMxrTbGPqVdvs8/0+3+/zfMcxhybpaUYnetGG
N7zgQ78r+LQLvVigq4AhTGMSWfgo4xFnOMIt6tEEDrowgSUsYEDVfGlNHZdYwybuowk6MIUV
zKNHFTmx1sawiBO8hglaMY5l5NW/EwuOtjmIHJo8vciq5DkFu6bxE2j9KoZtgox2z+uPtGCr
D/3hIXZjRr15Jv0J11TtIdrdRjGL9gY9m9hNOZqBGxzYBCO6rv/sbnSlD9jGrqszyKT0HQ1+
soGagwtX01WOLUxKYssuKXhDc+C7elmKTFv8xK2aet7COo413j99Bwm7hzv6Gt8r7GMHp/qw
fq+kor5qCnzHs2a+oOqKKrmorzGIJrjGngaoxR4MzhV8p4Dwc67+KTMXmG8BBgAGPmJtGrAs
BgAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 3/18/2010 18:17:00'!
ctMarkGreenIcon
	^ Icons
			at: #'ctMarkGreen'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctMarkGreenContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 3/18/2010 18:19:36'!
ctMarkGreenSmallIcon

	^ Icons
			at: #'ctMarkGreenSmall'
			ifAbsentPut:[ self ctMarkGreenIcon scaledToSize: 8@8 ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 3/18/2010 18:07:07'!
ctMarkRedContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAWRJREFUeNqM01srBGEcx/GZ8dh1yq5DyaF4BQ65kJTkwoV3
IC8PKVx4AXLJhZS9cEHKJmkRNjkudnz/+o2eJoOnPu00M//D/J9nwziOg2oYBj+sBjhdx7qO
UEcN7/bAZQTn0Y1eNCtZETnc4hiXeHWpQKvQhiFMY0qBVq0TBZxiDVuWxKVa7sEI5jGLQd23
BI0qYO+c4wT3zqtsD2awiEm0636g1m19KOEwJlBJEljbY1hQ660IMwZriUdxh32n7H2YU+Ws
4NC736Qh5yNtzwDGNbCsYH/VNMyr5Btb0JERnF52JsrahYtIE37Dyz+DK1jHtp2JyBtO7o8O
LPgGG2JbWY80kIJ+fwuuYhNLOFLXX/tc0BBzejHwfpPrB33zCg7tCKePbr8GGStzXdfmGXtY
xQGe/NaSg/SoKqFajXT2rVIJy9i1o+sHF/knOw1mR2fdujnTjnQpaUmVr9XZd7CtTwEGAH3d
WjFDP6vVAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 3/18/2010 18:16:28'!
ctMarkRedIcon
	^ Icons
			at: #'ctMarkRed'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctMarkRedContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 3/18/2010 18:19:09'!
ctMarkRedSmallIcon

	^ Icons
			at: #'ctMarkRedSmall'
			ifAbsentPut:[ self ctMarkRedIcon scaledToSize: 8@8 ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 3/18/2010 18:07:47'!
ctMarkYellowContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAV5JREFUeNqM080rRFEYx/F7596GGBMRC4rsSCklslMk2bK1
9Bf5B6Ts7JTYUPJWiMhKEpKI8Z68zPV99Ls6dGfMqU8z93af5zznOef4uchLGmVoRAfa9O4A
W7jCT1SYEFyNdoxgGM0IsIdJLONJST7cBL6CezGOAdQo2EYXxpDFBR5x7jtLqFLwBIb07I5P
3Cs4h2ssxBWk0YJRzZxJWFpKFWWV7BVvoUq3l30Y1H/fKzwCyVsPU3poQD+aNFOxESd/wVFK
AfVoLbArnrNtcbDNfoaduAJbc2WJwZGaadu5HzrnIfin5HhY89Ywh9NQwRUlrD1S8CamsW19
CFW+bWFdke5b8DM2MIUlLeN79rS6X6gH1rA7rGBGvzdxbyzBO27tUCiZO6sdmEssKnhXpzDv
XqYHrKJbytUPS3iCecziUOf/d4e5C/ZxLTrRo35k9LE1ah3HuoF/rm3kfQkwAMgHVkrmL7Ph
AAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 3/18/2010 18:16:44'!
ctMarkYellowIcon
	^ Icons
			at: #'ctMarkYellow'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctMarkYellowContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 3/18/2010 18:19:23'!
ctMarkYellowSmallIcon

	^ Icons
			at: #'ctMarkYellowSmall'
			ifAbsentPut:[ self ctMarkYellowIcon scaledToSize: 8@8 ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/3/2009 19:16'!
ctPaintcanContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAJVSURBVDjLlZPbS5NhHMd3tbvy
ov6HIJRuhKAFgRci5GXYVQkG0c6HJGvD1FVMjdxC22wlQ9iG7uBh0rtDmxtb77vFoh2c7KgM
tiGbU9xdgezb3hf0Ii3cxZfngef5fn6H5/ewALD+Vv8Upeh7HfzdM+pb4QwT7PPunOg8M7tl
Ph63JtE/4UM3f7WnLUDL3NE7vgmFKYbeF050Di3dbQvQSrvjzogTIm0Yt0WrePp25VNbAHcg
rLopXMOgyo/uR8v4bAnAbrdLLwSIRCLK1HYaHKEdnQ9MuHZ/Edv5MpYcHljc1K9Fgvo+uxqa
nLYEr5wBhMNhZTqdRr1ex6jOBz8VxzONC+VyGQcHB5g3rcFGZWH+lscrc9ArWdjseqzzXWLM
FEWdmnO5HEwbEYzpvmKZ+IFKpYJSqQS/3w/l+4XmlCXYnHGmMfTBOzyg9lxmkSQ5RpsbjQYK
hQKy2Syz7u/vM0Z6T5+73W44nU7IlOrmS9tPPJn3VfsmXVdZLfKbra0tVKtV7O7uYmdnh8mE
BtCwVCqFRCIBgiCg0Wggk8ko7sdNCMwJ3JogRpgSHA6HOhqN4ujoCIeHh6jVashkMkgmk4jH
4wgEApibm4NUKqVEIhH74awXrfSPbyi+dJ020Wg0vguFQtjb20M+n2eixmIxBqDX6+nIpFAo
ZMb63owHHCXhOvOMWq1W7fF4UCwWQZdFN9RqtdKRSYFAcPonrj/fGPznIKlUKvX6+jrTfZvN
BolEQvL5fPaFJ5GWXC5XGwwGiMViksfjtfcbT9Rq1gCXy/2vmdYfaGviUGKvapgAAAAASUVO
RK5CYII='! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/3/2009 19:16'!
ctPaintcanIcon
	^ Icons
			at: #'ctPaintcan'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctPaintcanContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 1/17/2010 17:32'!
ctPencilExContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAkhJREFUeNqkk8trE1EUxr+ZTGaaMY9iHpMm1ibFaCqUSgM+
KqiIdWFFBFF0paAbN+6K+icYXWipSKWrCkoNVikG3yAUYqBmwGq0j4ipJCXWvGqTpmkyM06m
KIZoCXjgbO49v+87h3sPIUkS/ieoegvjL7ZpClnHbOYbYRQFkWR1s1EtQ3fVLZBPO5ckwYb2
I6dBkCQmRi86svHMTaKeEWR3qdF2CZRuowwzypm4vIAJf59I1gObPP2g9ATioXsoJaeUrASp
olbW7OA3zGRRjPshLjH4zM9Dp7chORfB9guPCLIuOPEAkhAB09ICC0ehHAsqcKXurx3UwCsx
5EkzkjMBSPM0li0R4ldtTQevb7hrYLXlIFKRt2ju7EWRiw7Jng0V30pWCTz3bpE8J25VwbT1
EGJvnoBe5wDbyMHA7WsTRHSXBaCSisDAOaejArv3e/FxbLgK/h7gkU1/gtl9YOHUmfswNe3e
LArEUaEMSs5VgRIrftl1cghNG5xIfQiBf/UOiXQbwiMvEZ0aB9VsDUJYNPh8PhRyCQPNOrfK
7ntL5T9GYEgVfoxdh8euhcTHwA8OIz79FQVuesBgbXfNZcbhf9yLZHES6vVWV7mM46USVp8x
EM5h5lkfNK5uUDvOQ9rkAWuxgHSHuxjW1AFV3EiTSfQcvgqWWoRWWzSqG7QdsshOZRckkYD3
7lPsCQVh1TGgzYaRnivvj43eJgc5u75VQyYAtYh86jJyqYdKx1a7oXUylTu75k+8c43oF0V0
/ute3in+pwADAMMdEiSznbNwAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 1/17/2010 17:32'!
ctPencilExIcon

	^ Icons
			at: #'ctPencilEx'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctPencilExContents readStream) ].! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/30/2009 15:17'!
ctWorldContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAMtSURBVDjLVZNLa1xlAIafc5sz
k8xkMkkm5MKY2EpT2qa2MTVCmoLS2gq6EKooimAW7iQb/0I2bgTRIog0oFW7KQpCS7VqrSmm
JGlSQtswqWlLLmbGmcmcZM6cy/edz00r6bt8eXh4N6+mlGJnxiZHR4APgSNAFjCBKjClInXm
05Gzl3by2mPB2OSoCUwAp1/LHbcziSyO24gbgJAegg2urF8UUsifhZBvfvXK99v/C8YmRy3g
t8G2/cMv517E8Wx8ApYcjZiyKbkRSgQkcFn3rzG9Nn1LhOLYt2/8UNUfLZkYaN0zfLRrkLIM
CHUNIXTqIoZLjLJvU/ASrFQtnko+z2BH38HAD78DMConHh4FPn5nz6vGgqyxTp16JNj2kpR9
C8eD/OoW1VoNO1NCS+d5oW0vV27f2PX11MS8MTR6+JOTXUMHNCPBui5AtdMpk8xsGNQ9ndur
20TxCnbPIn5TnmJUwaxIDrTm9Jn7d1tM4EiuqZs5d41iXGefsZsIwYNCgOfVSXconJbLLEWb
4CuahU2+6HO8d4DQF/0m0NpgNvLAXaPgu6QadrEZpKhUItJZj/aMS1EewvHnsdUWW/+WKG82
kEykCAPRbCqlNE1B4DsocpiW5OJfIVoiyfqSQFdNdGXrpLZGcFZDPKYJg2VQCiGEZkoRlZ3A
6W41mknFn2WlaOKFFrG4Tbw9wb2/S3g3miHySLdbNDd2kzYKVGpVpIiqugjF7P3yQ55pyLFW
mCSyVokZPqHnEoYmsWQGuyWOGdexNIkRFOnqbGN5bRngjh4G4rMLd6+KnmQW012lWrpOJuNj
Ch9LU9i6gRkEZHIrpNv/QK8vcijXz5lfLijgS+PmuYV75+fPDXr1Wt9znfsouy5x+2miuolt
W1iawBJV0o0/wT8lBvbv5WZ+gaWNlasz43MfmQChH777e37uT78eHDx5+BiLBROjqhDaFmGk
Q1KS6+mlr7+XX2evc+nWVB54+4kznfr8pZQIxXkRyhPvDb9vIjtQqgFN12hLO2yUZ/ni8o8S
uAa8NTM+t/GE4HGGx4del0J+IGXUH8ko86iuAneAszPjc9/s5P8DuO6ZcsXuRqAAAAAASUVO
RK5CYII='! !

!MenuIcons class methodsFor: '*codetalk' stamp: 'mt 5/30/2009 15:18'!
ctWorldIcon

	^ Icons
			at: #'ctWorld'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self ctWorldContents readStream)].! !

!OBMethodVersionNode methodsFor: '*codetalk' stamp: 'mt 5/3/2009 10:02'!
categoryText

	^ self version category! !

!OBMethodVersionNode methodsFor: '*codetalk-override' stamp: 'mt 1/18/2010 09:23'!
definition
	^ (OBMethodDefinition source: self source inClass: self theClass)
		callback: [:sel | 
					version selector = sel
						ifTrue: [self class on: version latest]
						ifFalse: [OBMethodNode on: sel inClass: self theClass]]! !

!OBMethodVersionNode methodsFor: '*codetalk' stamp: 'mt 5/27/2009 10:39'!
hasVersions

	^ false! !

!OBMethodVersionNode methodsFor: '*codetalk' stamp: 'mt 1/18/2010 09:21'!
source

	^ self sourceText! !

!OBMethodVersionNode methodsFor: '*codetalk' stamp: 'mt 1/18/2010 09:24'!
sourceText
	"Style the method version source."
	
	| source |
	source := self version source.
	
	CtSourceTextStyler new
		styleSource: source
		markups: (CtMarkupDatabase local markupsForClass: self theClass selector: self selector version: self timeStamp)
		inClass: self theClass
		selector: self selector.
	
	^ source! !

!OBMethodVersionNode methodsFor: '*codetalk' stamp: 'mt 1/17/2010 11:38'!
timeStamp

	^ version stamp! !

!OBPluggableListMorph methodsFor: '*codetalk-override' stamp: 'mt 4/26/2009 21:32'!
listMorphClass
    ^CtLazyListMorph! !

OBLazyListMorph subclass: #CtLazyListMorph
	instanceVariableNames: 'showCategories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Kernel'!

!CtLazyListMorph methodsFor: 'displaying' stamp: 'mt 9/22/2010 15:27:39.396'!
display: item  atRow: row on: canvas
	"display the given item at row row"
	| drawBounds top icon node fontToUse |
	drawBounds := self drawBoundsForRow: row.
	drawBounds := drawBounds intersect: self bounds.
	node := listSource model children at: row.
	
	(listSource iconAt: row) ifNotNilDo: 
		[:name |
		icon := OBMorphicIcons iconNamed: name.
		top := drawBounds top + (drawBounds height - icon height // 2).
		canvas translucentImage: icon at: drawBounds left @ top.
		drawBounds := drawBounds left: drawBounds left + icon width + 2].
	
	fontToUse := item isText
		ifTrue: [font emphasized: (item emphasisAt: 1)]
		ifFalse: [font].
	
	canvas
		drawString: item
		in: drawBounds
		font: fontToUse
		color: (item isText ifTrue: [item colorAt: 1] ifFalse: [self colorForRow: row]).
	
	drawBounds := drawBounds left: drawBounds left + (fontToUse widthOfString: item asString).

	(node isKindOf: OBClassNode)
		ifTrue: [ drawBounds := self
			indicateMarkupForClass: node
			on: canvas
			in: drawBounds].

	(node isKindOf: OBMethodNode)
		ifTrue: [
			drawBounds := self
				indicateMarkupFor: node
				on: canvas
				in: drawBounds].

	(node isKindOf: OBMethodNode) "& (row ~= selectedRow)"
		ifTrue: [drawBounds := self
			displayCategoryFor: node
			in: drawBounds
			on: canvas].! !

!CtLazyListMorph methodsFor: 'displaying' stamp: 'mt 3/18/2010 19:47:42.669'!
displayCategoryFor: aMethodNode in: drawBounds on: aCanvas

	| txt |
	self updateProperties.
	(aMethodNode theClass isNil or: [showCategories not])
		ifTrue: [^ drawBounds].
	
	txt := ' ({1})' format: {aMethodNode categoryText}.
	showCategories ifTrue: [aCanvas
		drawString: txt
		in: drawBounds
		font: font
		color: ((aMethodNode categoryText = 'as yet unclassified')
			ifTrue: [Color red]
			ifFalse: [Color gray])].
		
	^ drawBounds left: drawBounds left + (font widthOfString: txt asString) + 2! !

!CtLazyListMorph methodsFor: 'displaying' stamp: 'bs 8/17/2010 18:11:15.873'!
indicateMarkupFor: aMethodNode on: aCanvas in: drawBounds

	| icon top newBounds |
	aMethodNode theClass ifNil: [^ drawBounds].
	
	newBounds := drawBounds left: drawBounds left + 4.
	(CtMarkupDatabase local
		markupsForClass: aMethodNode theClass
		selector: aMethodNode selector)
		do: [ :markup |
			icon := markup tag = #bad
				ifTrue: [MenuIcons ctMarkRedSmallIcon]
				ifFalse: [markup tag = #comment
					ifTrue: [MenuIcons ctMarkGreenSmallIcon]
					ifFalse: [MenuIcons ctMarkYellowSmallIcon]].
			top := newBounds top + (newBounds height - icon height // 2) + 1.
			aCanvas translucentImage: icon at: newBounds left @ top.
			newBounds := newBounds left: newBounds left + icon width].
	^ newBounds! !

!CtLazyListMorph methodsFor: 'displaying' stamp: 'mt 3/19/2010 11:51:10.478'!
indicateMarkupForClass: aClassNode on: aCanvas in: drawBounds

	| icon top newBounds |
	aClassNode theClass ifNil: [^ drawBounds].
	
	newBounds := drawBounds left: drawBounds left + 4.
	(CtMarkupDatabase local
		markupsForClass: aClassNode theClass)
		do: [ :markup |
			icon := markup tag = #bad
				ifTrue: [MenuIcons ctMarkRedSmallIcon]
				ifFalse: [markup tag = #comment
					ifTrue: [MenuIcons ctMarkGreenSmallIcon]
					ifFalse: [MenuIcons ctMarkYellowSmallIcon]].
			top := newBounds top + (newBounds height - icon height // 2) + 1.
			aCanvas translucentImage: icon at: newBounds left @ top.
			newBounds := newBounds left: newBounds left + icon width].
	^ newBounds! !

!CtLazyListMorph methodsFor: 'accessing' stamp: 'mt 5/1/2009 17:03'!
updateProperties

	showCategories ifNil: [showCategories := 
		(Preferences
			preferenceAt: #showProtocolForMessage
			ifAbsent: [Preference new rawValue: false])
			preferenceValue].! !

!OBCmdMultiView methodsFor: '*codetalk-override' stamp: 'mt 3/18/2010 20:07:40.392'!
execute
	"CodeTalk: Add a new menu item for CodeTalk styling. Recover original styler for shout first."
	
	|viewType|
	viewType := OBChoiceRequest
		prompt: nil 
		labels: #('source' 'pretty print' 'decompile' 'byte codes' 'source with markups') 
		values: #(showSource showPrettyPrint showDecompile showByteCodes showMarkups).
	self styler: SHTextStylerST80 new.
	viewType ifNotNil: [self perform: viewType]! !

!OBCmdMultiView methodsFor: '*codetalk' stamp: 'mt 3/19/2010 10:04:25.778'!
showMarkups

	self
		styler: CtTextStyler new;
		definition: target definition.! !

!OBCmdMultiView methodsFor: '*codetalk' stamp: 'mt 6/11/2009 18:22'!
styler: styler
	"Proxy: Look for the current pluggable text morph in the definition panel and set the styler."
	
	| panel morph |
	panel := requestor browser definitionPanel. 
	morph := OBPluggableTextMorph allSubInstances
		detect: [:each | each model == panel]
		ifNone: [^ self].
	morph styler: (styler view: morph).! !

OBTextMorphEditorWithShout subclass: #CtEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Kernel'!

!CtEditor class methodsFor: 'initialization' stamp: 'mt 6/23/2009 09:41'!
initializeCmdKeyShortcuts

	super initializeCmdKeyShortcuts.
	CmdActions
		at: ($t asInteger + 1) put: #sAddCodeChat:;
		at: ($r asInteger + 1) put: #sMarkAsBad:.! !

!CtEditor methodsFor: 'editing' stamp: 'mt 1/21/2010 16:25'!
accept

	| result txt |
	txt := self text.
	result := super accept.

	self
		storeMarkupsForCompiledMethod: self compiledMethod
		source: txt;
		forceRestyleFor: self compiledMethod.
	
	^ result! !

!CtEditor methodsFor: 'actions' stamp: 'mt 1/17/2010 15:14'!
addCodeChat

	self tagSelectionWith: #talk.! !

!CtEditor methodsFor: 'actions' stamp: 'mt 1/17/2010 15:48'!
addComment

	self tagSelectionWith: #comment.! !

!CtEditor methodsFor: 'private' stamp: 'mt 1/17/2010 16:28'!
addMarkup: aMarkup

	CtSourceTextStyler new
		styleSource: self text
		markup: aMarkup
		inClass: self theClass
		selector: self selector.
	
	"Set dependent for new reference attribute to let iconic buttons work."
	((self text attributesOfKind: CtReferenceAttribute)
		detect: [:attr | attr markup = aMarkup]) addDependent: morph.
		
	morph changed. "force redraw"! !

!CtEditor methodsFor: 'actions' stamp: 'mt 1/17/2010 16:59'!
changeMarkupTag

	| result |
	result := UITheme current
		chooseDropListIn: self morph
		text: 'Select a new tag:'
		title: 'Change Markup Tag' list: CtMarkup tags.
		
	result ifNil: [^ self].
	
	self changeTagInSelectionTo: result.! !

!CtEditor methodsFor: 'initialize-release' stamp: 'mt 1/22/2010 13:06:17'!
changeParagraph: aParagraph
	"Add a back reference to the textmorph to the paragraph."

	super changeParagraph: aParagraph.
	(aParagraph isKindOf: CtParagraph) & (morph isKindOf: CtTextMorph)
		ifTrue: [
			aParagraph textMorph: morph.
			morph removeAllMorphs.
			(aParagraph text attributesOfKind: CtReferenceAttribute)
				do: [:attr | attr addDependent: morph]].! !

!CtEditor methodsFor: 'editing' stamp: 'mt 1/17/2010 17:22'!
changeTagInSelectionTo: aSymbol
	"Used to change the tag (#bad, #talk) )of an attribute in the text."

	| attrs |
	attrs := self text
		attributesOfKind: CtReferenceAttribute
		from: self startIndex
		to: self stopIndex - 1.
		
	attrs	do: [:ref |
		ref markup tag: aSymbol.
		(ref friends
			detect: [:friend | friend isKindOf: CtTextBackgroundColor])
			color: ref markup color.
		(ref friends
			detect: [:friend | friend isKindOf: CtIconBarAttribute])
			mode: ref markup tag].
	morph changed.
! !

!CtEditor methodsFor: 'accessing' stamp: 'mt 1/17/2010 20:21'!
compiledMethod

	self theClass ifNil: [^ nil].
	self selector ifNil: [^ nil].
	^ self theClass >> self selector! !

!CtEditor methodsFor: 'actions' stamp: 'mt 6/11/2009 17:32'!
convertInlineComment
	"Convenient method that creates a custom text selection."

	self convertInlineComment:
		(OBTextSelection on: self selectionInterval inText: self text).! !

!CtEditor methodsFor: 'actions' stamp: 'mt 1/17/2010 16:54'!
convertInlineComment: aTextSelection

	(self doConvertInlineComment: aTextSelection)
		ifTrue: [self userHasEdited].! !

!CtEditor methodsFor: 'private' stamp: 'mt 1/17/2010 18:06'!
copyLastVersion: aMethodRecord
	"Enable copy-on-write in the database and refresh present references."

	aMethodRecord copyLastVersion "copy-on-write"
		ifNotEmptyDo: [:mapping |
			(self text attributesOfKind: CtReferenceAttribute) do: [:ref |
				ref markup: (mapping at: ref markup)]].! !

!CtEditor methodsFor: 'menu messages' stamp: 'mig 5/29/2010 10:49:29.043'!
copySelection
	"A modified copy of ParagraphEditor>>#copySelection:
	Copies only the string instead of the full Text to avoid copying CodeTalk Annotations."

	"Copy the current selection and store it in the paste buffer, unless a caret.  Undoer & Redoer: undoCutCopy"

	self lineSelectAndEmptyCheck: [^ self].

	"Simulate 'substitute: self selection' without locking the controller"
	UndoSelection := self selection asString.
	self undoer: #undoCutCopy: with: self clipboardText.
	UndoInterval := self selectionInterval.
	self clipboardTextPut: UndoSelection! !

!CtEditor methodsFor: 'private' stamp: 'mt 1/18/2010 09:26'!
detachAllMarkups
	"Follow all references to the markups, clone them and be prepared for non-live-edit-mode."

	(self text attributesOfKind: CtReferenceAttribute)
		do: [:ref | ref markup: ref markup clone].! !

!CtEditor methodsFor: 'editing' stamp: 'mt 3/19/2010 11:40:01.814'!
doConvertInlineComment: aTextSelection
	"Scan comments in text selection and put them into a complex attribute."

	| ranges result commentData markup |
	(aTextSelection fullText
		includesAttributesOfKind: CtReferenceAttribute
		from: aTextSelection start
		to: aTextSelection stop)
		ifTrue: [^ false]. "Must not overwrite other attributes!!"
	
	ranges := SHParserST80 new parseSource: aTextSelection fullText.
	result := aTextSelection text asString.
	commentData := ''.
	
	ranges 
		select: [:range | range type == #comment] 
		thenDo: [:range |
			(range start >= aTextSelection start and: [range end <= aTextSelection stop])
				ifTrue: [ | comment | 
					comment := aTextSelection fullText asString copyFrom: range start to: range end.
					result := result copyReplaceAll: comment with: '' asTokens: false. 
					commentData := commentData, comment withoutQuoting, String cr, String cr]].
	
	commentData isEmpty | result isEmpty
		ifTrue: [^ false].
	
	markup := CtMarkup forTag: #comment.
	markup
		comment: commentData;
		range: (aTextSelection start to: aTextSelection start + result size - 1).
	
	self
		replaceSelectionWith: result asText;
		addMarkup: markup.

	^ true! !

!CtEditor methodsFor: 'private' stamp: 'mt 1/21/2010 16:25'!
forceRestyleFor: aCompiledMethod
	"Remove all CodeTalk text attributes from text and reset them."
	
	(morph text attributesOfKind: CtTextAttribute)
		do: [:attr | morph text removeAttribute: attr].
		
	CtSourceTextStyler new
		styleSource: morph text
		of: aCompiledMethod.

	(morph text attributesOfKind: CtReferenceAttribute)
		do: [:attr | attr addDependent: morph]. "to make the icons work"
		
	morph changed.! !

!CtEditor methodsFor: 'testing' stamp: 'mt 1/17/2010 14:53'!
isInLiveEditMode
	"Live edit mode enables the developer to add, edit or delete markups without the need to save the method and create a new version. Once the developer changed something in the method's source, live-edit-mode will be disabled. A save operation will then trigger a new markup version for the method."
	
	^ morph hasUnacceptedEdits not! !

!CtEditor methodsFor: 'actions' stamp: 'mt 1/17/2010 15:48'!
markAsBad

	self tagSelectionWith: #bad.! !

!CtEditor methodsFor: 'actions' stamp: 'bs 12/15/2009 14:15'!
markForRefactoring
	| definition |
	self startIndex = self stopIndex ifTrue: [^ false].
	self model isDefinition ifTrue: [
		definition := self model getDefinition.
		Transcript cr; show: definition asString.
		(definition isKindOf: OBMethodDefinition) ifTrue: [
			Transcript cr; show: definition compileSelector asString] ]
	"(self tagSelectionWith: #bad)
		ifTrue: [self userHasEdited]."! !

!CtEditor methodsFor: 'private' stamp: 'mt 1/17/2010 16:28'!
removeAttribute: aReferenceAttribute

	aReferenceAttribute friends do: [:attr |
		self text removeAttribute: attr].
	self text removeAttribute: aReferenceAttribute.
	
	morph changed. "force redraw"! !

!CtEditor methodsFor: 'actions' stamp: 'mt 1/17/2010 15:05'!
removeMarkup

	self untagSelection.! !

!CtEditor methodsFor: 'actions' stamp: 'mt 1/17/2010 18:08'!
removeMarkup: aReferenceAttribute

	self isInLiveEditMode
		ifTrue: [ | record |
			record := (CtMarkupDatabase local at: aReferenceAttribute theClass)
				at: aReferenceAttribute selector.
			self copyLastVersion: record. "copy-on-write"
			record lastVersion remove: aReferenceAttribute markup].

	self removeAttribute: aReferenceAttribute.! !

!CtEditor methodsFor: 'actions' stamp: 'mt 1/17/2010 16:26'!
resizeMarkup

	self resizeTagInSelection.! !

!CtEditor methodsFor: 'editing' stamp: 'mt 1/17/2010 17:23'!
resizeTagInSelection
	"Used to grow or shrink the extent of an attribute in the text."

	| attrs markup |
	self startIndex = self stopIndex ifTrue: [^ false].
	attrs := self text
		attributesOfKind: CtReferenceAttribute
		from: self startIndex
		to: self stopIndex - 1.
	
	attrs size > 1
		ifTrue: [^ self. "Can only modify one attribute here."].
	
	markup := attrs first markup.
	markup range: (self startIndex to: self stopIndex - 1).
	self
		removeAttribute: attrs first;
		addMarkup: markup.! !

!CtEditor methodsFor: 'actions-shortcuts' stamp: 'mt 6/23/2009 09:42'!
sAddCodeChat: aCharacterStream
	"This method is intended to be used only via the shortcut mechanism. The stream will not be used."
	
	self addCodeChat.
	^ true! !

!CtEditor methodsFor: 'actions-shortcuts' stamp: 'mt 6/23/2009 09:42'!
sAddComment: aCharacterStream
	"This method is intended to be used only via the shortcut mechanism. The stream will not be used."
	
	self addComment.
	^ true! !

!CtEditor methodsFor: 'actions-shortcuts' stamp: 'mt 6/23/2009 09:42'!
sMarkAsBad: aCharacterStream
	"This method is intended to be used only via the shortcut mechanism. The stream will not be used."
	
	self markAsBad.
	^ true! !

!CtEditor methodsFor: 'accessing' stamp: 'mt 1/17/2010 15:40'!
selector

	self model isDefinition ifTrue: [
		| def |
		def := self model getDefinition.
		(def isKindOf: OBMethodDefinition) ifTrue: [
			^ def selector]].
	^ nil! !

!CtEditor methodsFor: 'private' stamp: 'mig 5/30/2010 19:44:22.084'!
storeMarkupsForCompiledMethod: aCompiledMethod source: aText

	| markups record someReferences |
	someReferences := aText attributesOfKind: CtReferenceAttribute.
	someReferences do: [:ref | ref selector: self selector].
	
	someReferences ifEmpty: [
		"Avoid empty garbage in the database."
		(CtMarkupDatabase local includes: self theClass)
			ifTrue: [| classRecord |
				classRecord := CtMarkupDatabase local at: self theClass.
				(classRecord includes: self selector)
					ifTrue: [| methodRecord |
						methodRecord := classRecord at: self selector.
						(methodRecord markups notEmpty and: [(methodRecord at: aCompiledMethod) notEmpty])
							ifTrue: [methodRecord clearLastVersion]]].
		^ self].
	
	record := (CtMarkupDatabase local at: self theClass) at: self selector.
	markups := record at: aCompiledMethod.
	
	record clearLastVersion. "implies copy-on-write"
	record lastVersion addAll: (someReferences collect: [:ref |
		| m |
		m := ref markup.
		m range: (aText find: ref).
		m]).
! !

!CtEditor methodsFor: 'editing' stamp: 'mt 1/17/2010 18:18'!
tagSelectionWith: aSymbol
	"Tag the selected code or text with the symbol."

	| markup |
	self startIndex = self stopIndex ifTrue: [^ self].
	markup := CtMarkup forTag: aSymbol.
	markup range: (self startIndex to: self stopIndex - 1).

	self isInLiveEditMode
		ifTrue: [ | record |
			record := (CtMarkupDatabase local at: self theClass)
				at: self selector.
			self copyLastVersion: record. "copy-on-write"
			(record at: self theClass >> self selector) add: markup].
	
	self addMarkup: markup.! !

!CtEditor methodsFor: 'accessing' stamp: 'mt 1/17/2010 15:40'!
theClass

	self model isDefinition ifTrue: [
		| def |
		def := self model getDefinition.
		(def isKindOf: OBMethodDefinition) ifTrue: [
			^ def theClass]].
	^ nil! !

!CtEditor methodsFor: 'editing' stamp: 'mt 1/17/2010 15:06'!
untagSelection

	(self text
		attributesOfKind: CtReferenceAttribute
		from: self startIndex
		to: self stopIndex - 1) do: [:attr |
			self removeMarkup: attr].! !

!CtEditor methodsFor: 'backspace handling' stamp: 'mt 1/17/2010 21:03'!
userHasEdited

	morph hasUnacceptedEdits
		ifFalse: [self detachAllMarkups "only do it once"].
	^ super userHasEdited
	! !

ImageMorph subclass: #CtAttributeIconMorph
	instanceVariableNames: 'attribute lastVisible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Kernel'!

!CtAttributeIconMorph methodsFor: 'accessing' stamp: 'mt 6/11/2009 21:27'!
attribute

	^ attribute! !

!CtAttributeIconMorph methodsFor: 'accessing' stamp: 'mt 6/11/2009 21:27'!
attribute: anObject

	attribute := anObject.! !

!CtAttributeIconMorph methodsFor: 'event handling' stamp: 'mt 1/22/2010 11:00:13'!
cleanUp
	"Perform some cleanup operations."! !

!CtAttributeIconMorph methodsFor: 'event handling' stamp: 'mt 7/2/2009 22:33'!
handlesMouseDown: evt

	^ true! !

!CtAttributeIconMorph methodsFor: 'accessing' stamp: 'mt 5/3/2009 19:43'!
visible: aBoolean

	lastVisible = aBoolean ifTrue: [^ self].
	lastVisible := aBoolean.
	self disableTableLayout: aBoolean not.
	^ super visible: aBoolean! !

CtAttributeIconMorph subclass: #CtChatIconMorph
	instanceVariableNames: 'chat'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Kernel'!

!CtChatIconMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 15:16'!
balloonText

	^ 'View chat'! !

!CtChatIconMorph methodsFor: 'accessing' stamp: 'mt 4/30/2009 14:49'!
chat

	chat ifNil: [chat := CtCodeChatMorph forAttribute: self attribute].
	^ chat! !

!CtChatIconMorph methodsFor: 'event handling' stamp: 'mt 1/22/2010 11:03:46'!
cleanUp

	super cleanUp.
	chat ifNotNilDo: [:chatMorph | chatMorph delete].! !

!CtChatIconMorph methodsFor: 'initialization' stamp: 'mt 6/2/2009 15:07'!
initialize

	super initialize.
	self image: (MenuIcons ctCommentsIcon).! !

!CtChatIconMorph methodsFor: 'event handling' stamp: 'mt 5/2/2010 14:48:49.445'!
mouseDown: evt

	self attribute ifNil: [^ self].
	self attribute read.
	self chat
		initialize;
		position: self positionInWorld;
		attribute: self attribute;
		openInWorld;
		extent: 260@200.! !

CtAttributeIconMorph subclass: #CtCommentIconMorph
	instanceVariableNames: 'editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Kernel'!

!CtCommentIconMorph methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:45'!
balloonText

	^ 'View comment'! !

!CtCommentIconMorph methodsFor: 'event handling' stamp: 'mt 1/22/2010 11:05:17'!
cleanUp

	super cleanUp.
	editor ifNotNilDo: [:editorMorph | editorMorph delete].! !

!CtCommentIconMorph methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:46'!
editor

	editor ifNil: [editor := CtCommentEditorMorph forAttribute: self attribute].
	^ editor! !

!CtCommentIconMorph methodsFor: 'initialization' stamp: 'mt 5/28/2009 20:12'!
initialize

	super initialize.
	self image: MenuIcons ctCommentIcon.! !

!CtCommentIconMorph methodsFor: 'event handling' stamp: 'mt 5/2/2010 16:37:01.163'!
mouseDown: evt

	self attribute ifNil: [^ self].
	self attribute read.
	self editor
		initialize;
		position: self positionInWorld;
		attribute: self attribute;
		openInWorld;
		extent: 260@200.! !

CtAttributeIconMorph subclass: #CtDeleteIconMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Kernel'!

!CtDeleteIconMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 15:16'!
balloonText

	^ 'Delete markup'! !

!CtDeleteIconMorph methodsFor: 'initialization' stamp: 'mt 5/1/2009 17:55'!
initialize

	super initialize.
	self image: (MenuIcons ctDeleteIcon).! !

!CtDeleteIconMorph methodsFor: 'event handling' stamp: 'mt 5/1/2009 17:55'!
mouseDown: evt

	self attribute ifNil: [^ self].
	self attribute requestDeletion.! !

CtAttributeIconMorph subclass: #CtResizeIconMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Kernel'!

!CtResizeIconMorph methodsFor: 'accessing' stamp: 'mt 5/3/2009 19:17'!
balloonText

	^ 'Resize markup'! !

!CtResizeIconMorph methodsFor: 'initialization' stamp: 'mt 5/3/2009 19:18'!
initialize

	super initialize.
	self image: (MenuIcons ctPaintcanIcon).! !

!CtResizeIconMorph methodsFor: 'event handling' stamp: 'mt 5/3/2009 19:19'!
mouseDown: evt

	self attribute ifNil: [^ self].
	self attribute requestResizing.! !

!OBCodeBrowser methodsFor: '*codetalk' stamp: 'mt 5/30/2009 15:07'!
cmdCodeTalk
	^ CtEditCommand allSubclasses! !

TestCase subclass: #CtDatabaseTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Tests'!

!CtDatabaseTest methodsFor: 'as yet unclassified' stamp: 'mt 1/16/2010 15:11'!
setUp

	super setUp.
	sut := CtMarkupDatabase new.! !

!CtDatabaseTest methodsFor: 'as yet unclassified' stamp: 'mt 1/16/2010 15:28'!
testClassRecord

	| class record |
	class := CtClassRecord.
	record := CtClassRecord newFrom: class.
	
	self
		should: record theClassName = #CtClassRecord;
		should: record theClass = class;
		should: record methodRecords isEmpty;
		shouldnt: (record includes: #theClassName);
		should: record methodRecords isEmpty;
		should: ((record at: #theClassName) isKindOf: CtMethodRecord);
		should: (record includes: #theClassName);
		shouldnt: record methodRecords isEmpty.
! !

!CtDatabaseTest methodsFor: 'as yet unclassified' stamp: 'mt 1/16/2010 15:32'!
testInitialState

	self
		should: sut classRecords isEmpty;
		should: sut packageRecords isEmpty! !

!CtDatabaseTest methodsFor: 'as yet unclassified' stamp: 'mt 1/16/2010 15:23'!
testMethodRecord

	| method record |
	method := CtMethodRecord>>#atSeconds:.
	record := CtMethodRecord newFrom: method.
	record addVersion: method.
	
	self
		should: record selector = #atSeconds:;
		should: ((record at: method) isKindOf: Collection);
		should: (record at: method) isEmpty.
	! !

!CtDatabaseTest methodsFor: 'as yet unclassified' stamp: 'mt 1/16/2010 15:57'!
testMethodRecordVersion

	| method record |
	method := CtMethodRecord>>#atSeconds:.
	record := CtMethodRecord newFrom: method.
	
	record addVersion: 0. "use dummy timestamp"
	(record markups at: 0) add: CtMarkup new.
		
	self should: (record at: method) = (record markups at: 0).

	record copyLastVersion.
	
	self
		shouldnt: (record at: method) = (record markups at: 0);
		should: (record at: method) size = 1.! !

TestCase subclass: #CtMarkupTest
	instanceVariableNames: 'sut sut2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Tests'!

!CtMarkupTest methodsFor: 'running' stamp: 'mt 1/16/2010 16:27'!
setUp

	super setUp.
	sut := CtMarkup forTag: #bad.
	sut
		addChatLine: 'She sells sea shells at the sea shore.';
		creator: Utilities authorInitials, 'test'.
	sut2 := CtMarkup forTag: #comment.
	sut2 comment: 'This is just a comment'.! !

!CtMarkupTest methodsFor: 'tests' stamp: 'mt 1/16/2010 16:27'!
testChatLineTrimmed

	sut addChatLine: 'Foobar.'.
	self should: (sut chat last at: #message) = 'Foobar.'.
	sut addChatLine: '  
	Foobar.
	  '.
	self should: (sut chat last at: #message) = 'Foobar.'.! !

!CtMarkupTest methodsFor: 'tests' stamp: 'mt 1/16/2010 16:28'!
testCommentTrimmed
	"Remove all trailing or leading blanks from a comment when it is set."
	
	sut comment: 'foobar'.
	self should: sut comment = 'foobar'.
	sut comment: '  foobar  '.
	self should: sut comment = 'foobar'.! !

!CtMarkupTest methodsFor: 'tests' stamp: 'mt 1/16/2010 16:28'!
testInstanceCreation

	self
		should: sut tag = #bad;
		should: sut creator = (Utilities authorInitials, 'test');
		should: sut chat size = 1;
		should: (sut chat first at: #author) = Utilities authorInitials;
		should: sut timestamp <= (sut chat first at: #timestamp)! !

!CtMarkupTest methodsFor: 'tests' stamp: 'mt 1/16/2010 16:28'!
testReading

	CtMarkup reset. "Clear read cache."
	self
		shouldnt: (CtMarkup wasRead: sut);
		shouldnt: (CtMarkup wasRead: sut2).
	CtMarkup read: sut.
	self
		should: (CtMarkup wasRead: sut);
		shouldnt: (CtMarkup wasRead: sut2).
	self
		shouldnt: [CtMarkup
			read: sut;
			read: sut] raise: Error.! !

!CtMarkupTest methodsFor: 'tests' stamp: 'mt 1/16/2010 16:28'!
testRegex
	
	self should: ('([A-Z]\w*)(\sclass)?>>#?(\w[\w:]*)' asRegex isKindOf: RxMatcher).! !

!CtMarkupTest methodsFor: 'tests' stamp: 'mt 1/16/2010 16:28'!
testTagAcccessing

	self should: sut tag = #bad.
	sut tag: #'0'.
	self should: sut tag isNil.
	sut tag: #talk.
	self should: sut tag = #talk.
	sut tag: #shouldNotBeAllowed.
	self should: sut tag isNil.! !

TestCase subclass: #CtMonticelloTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Tests'!

!CtMonticelloTest class methodsFor: 'marking' stamp: 'cs 5/4/2009 02:05'!
markCollection: anAttribute

	| source ref |
	ref := MethodReference class: Collection selector: #do:.
	source := ref sourceCode.
	(source attributesOfKind: XpfComplexAttribute)
		do: [:att | source removeAttribute: att ].
	source addAttribute: anAttribute from: 1 to: 1.
	Collection compile: source classified: ref category.
	^ ref! !

!CtMonticelloTest class methodsFor: 'marking' stamp: 'mt 5/5/2009 15:05'!
markCollectionDoBad
	^ self markCollection: (XpfComplexAttribute forTag: #bad)! !

!CtMonticelloTest class methodsFor: 'marking' stamp: 'cs 5/2/2009 12:58'!
markCollectionDoNormal

	| source ref |
	ref := MethodReference class: Collection selector: #do:.
	source := ref sourceCode.
	Collection compile: source asString classified: ref category.
	^ ref! !

!CtMonticelloTest methodsFor: 'tests' stamp: 'mt 5/5/2009 15:05'!
testAddCodeMarkup
	| ref source md snapshotBin md2 color |
	ref := self class markCollectionDoBad.
	source := ref sourceCode.
	color := ((source attributesAt: 1) detect: [ :attr | attr isKindOf: XpfComplexAttribute ]) color.
	md := (Collection compiledMethodAt: #do:) methodReference asMethodDefinition.
	snapshotBin := MCMczWriter new serializeInBinary: (MCSnapshot fromDefinitions: {  md  }).
	md2 := (DataStream on: ((RWBinaryOrTextStream with: snapshotBin)
			reset;
			yourself)) next definitions first.
	self
		should: md2 source isString;
		should: md2 sourceText isText;
		should: md source = md2 source;
		should: ((md2 sourceText attributesAt: 1) anySatisfy: [ :attr | (attr isKindOf: XpfComplexAttribute) and: [ attr color = color ] ]).

	"Clean up"
	self class markCollectionDoNormal! !

!CtMonticelloTest methodsFor: 'tests' stamp: 'mig 5/25/2010 13:47:46.048'!
testDefinitionFromReference

	| ref cm md |
	ref := MethodReference class: Collection selector: #do:.
	cm := Collection compiledMethodAt: #do:.
	md := ref asMethodDefinition.
	
	self
		should: cm getSource = ref sourceCode;
		should: ref sourceCode isText;
		should: ref source isString;
		should: md source isString.! !

TestCase subclass: #CtServerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Tests'!

!CtServerTest commentStamp: 'mig 6/20/2010 16:14:26.06' prior: 0!
This TestCase tests the CodeTalk synchronization behaviour.!

!CtServerTest methodsFor: 'as yet unclassified' stamp: 'mig 6/22/2010 10:10:51.133'!
testScenario1

	| db1 db2 server timestamp |
	db1 := CtMarkupDatabase new.
	db2 := CtMarkupDatabase new.
	server := CtServer new.
	
	timestamp := TimeStamp now.
	
	(db1 markupsForClass: #NotExistingClass selector: #notExistingSelector version: timestamp)
		add: CtMarkup new.

	"synchronize both databases, markup should be in db2 afterwards"
	server synchronize: db1.
	server synchronize: db2.
	
	self assert: (db2 markupsForClass: #NotExistingClass selector: #notExistingSelector version: timestamp) size == 1.
! !

!OBTextSelection methodsFor: '*codetalk' stamp: 'mt 5/3/2009 18:39'!
start

	^ selection first! !

!OBTextSelection methodsFor: '*codetalk' stamp: 'mt 5/3/2009 18:39'!
stop

	^ selection last! !

BorderedMorph subclass: #CtAttributeEditorMorph
	instanceVariableNames: 'model closeButton title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Morphs'!

!CtAttributeEditorMorph class methodsFor: 'constants' stamp: 'mt 5/28/2009 19:37'!
defaultExtent

	^ 200@150! !

!CtAttributeEditorMorph class methodsFor: 'instance creation' stamp: 'mt 5/28/2009 19:37'!
forAttribute: anXpfAttribute

	^ self new
		attribute: anXpfAttribute! !

!CtAttributeEditorMorph class methodsFor: 'constants' stamp: 'mt 5/28/2009 19:39'!
modelClass

	^ self subclassResponsibility! !

!CtAttributeEditorMorph methodsFor: 'accessing' stamp: 'mt 5/2/2010 14:45:14.127'!
attribute: anXpfAttribute

	self model ifNil: [^ self].
	self model attribute: anXpfAttribute.
	self title contents: ('{1} - {2}' format: {
			anXpfAttribute timestamp printRelativeTimeStamp.
			anXpfAttribute creator}).
	self color: (anXpfAttribute color copy lighter lighter alpha: 0.8).! !

!CtAttributeEditorMorph methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:28'!
closeButton

	closeButton ifNil: [closeButton := IconicButton new
			color: (Color white alpha: 0.5);
			target: self;
			borderWidth: 0;
			labelGraphic: MenuIcons ctCrossIcon;
			actionSelector: #delete;
			useRoundedCorners;
			setBalloonText: 'Close window'].
	^ closeButton! !

!CtAttributeEditorMorph methodsFor: 'drawing' stamp: 'mt 5/2/2010 14:41:16.555'!
drawOn: aCanvas

	super drawOn: aCanvas.
	
	aCanvas
		frameRectangle: (self bounds insetBy: (1@1))
		color: (self color muchDarker).
	
	aCanvas
		line: self topLeft + (1 @ 1)
		to: self topRight + (-1 @ 1)
		color: (self color muchLighter).

	aCanvas
		line: self topLeft + (1 @ 1)
		to: self bottomLeft + (1 @ -2)
		color: (self color muchLighter).
	
	aCanvas
		frameRectangle: self bounds
		color: (self color muchDarker muchDarker)..
! !

!CtAttributeEditorMorph methodsFor: 'initialization' stamp: 'mt 5/2/2010 14:40:39.067'!
initialize

	super initialize.
	self
		hResizing: #rigid;
		vResizing: #rigid;
		listDirection: #topToBottom;
		borderWidth: 0;
		changeTableLayout;
		layoutInset: 5;
		cellInset: 5;
		extent: 250@200;
		initializeUserInterface.! !

!CtAttributeEditorMorph methodsFor: 'initialization' stamp: 'mt 5/28/2009 19:29'!
initializeUserInterface

	^ self subclassResponsibility! !

!CtAttributeEditorMorph methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:40'!
model

	model ifNil: [model := self class modelClass new].
	^ model! !

!CtAttributeEditorMorph methodsFor: 'accessing' stamp: 'mt 3/19/2010 10:52:27.579'!
title

	title ifNil: [title := 'Editor' asText asMorph.
		title hResizing: #spaceFill.
		title assureExtension
			balloonText: 'Creation time and creator'].
	^ title! !

CtAttributeEditorMorph subclass: #CtCodeChatMorph
	instanceVariableNames: 'chatLog textEntry addMessageButton searchEntry searchButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Morphs'!

!CtCodeChatMorph class methodsFor: 'constants' stamp: 'mt 5/28/2009 19:39'!
modelClass

	^ CtCodeChatModel! !

!CtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 17:56'!
addMessageButton

	addMessageButton ifNil: [addMessageButton := IconicButton new
			color: (Color white alpha: 0.5);
			target: self textEntry;
			borderWidth: 0;
			labelGraphic: MenuIcons ctCommentAddIcon;
			actionSelector: #accept;
			useRoundedCorners;
			setBalloonText: 'Add message'].
	^ addMessageButton! !

!CtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/2/2010 14:27:15.644'!
chatLog

	chatLog ifNil: [chatLog := CtChatLog
		on: self model
		text: #messages
		accept: nil].
	^ chatLog! !

!CtCodeChatMorph methodsFor: 'initialization' stamp: 'mt 4/14/2010 16:50:01.479'!
initializeUserInterface

	self
		addMorphBack: (SwaRowPanel for: {
			self title.
			self closeButton});
		"addMorphBack: (self newRowFor: {
			self searchEntry.
			self searchButton});"
		addMorphBack: self chatLog;
		addMorphBack: (SwaRowPanel for: {
			self textEntry.
			self addMessageButton}).! !

!CtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/3/2009 14:18'!
searchButton

	searchButton ifNil: [searchButton := IconicButton new
			color: (Color white alpha: 0.5);
			target: self searchEntry;
			borderWidth: 0;
			labelGraphic: MenuIcons ctMagnifierIcon;
			actionSelector: #accept;
			useRoundedCorners;
			setBalloonText: 'Highlight messages with keyword.'].
	^ searchButton! !

!CtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/3/2009 14:19'!
searchEntry

	searchEntry ifNil: [searchEntry := UITheme current
		newTextEntryIn: self
		for: self model
		get: nil
		set: #searchString:
		class: String
		getEnabled: nil
		help: 'Type a keyword to hightlight messages which contain that keyword.'.
		searchEntry
			useRoundedCorners;
			borderWidth: 0;
			fillStyle: (Color white alpha: 0.5);
			setText: 'Look for keyword...'].
	^ searchEntry! !

!CtCodeChatMorph methodsFor: 'accessing' stamp: 'mt 5/2/2010 11:34:58.179'!
textEntry

	textEntry ifNil: [textEntry := SwaLineEdit
		for: self model
		get: #newMessage
		set: #addMessage:.
		textEntry
			borderWidth: 0;
			fillStyle: (Color white alpha: 0.5);
			setText: 'Type message here...';
			acceptOnCR: true].
	^ textEntry! !

CtAttributeEditorMorph subclass: #CtCommentEditorMorph
	instanceVariableNames: 'commentField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Morphs'!

!CtCommentEditorMorph class methodsFor: 'constants' stamp: 'mt 5/28/2009 19:39'!
modelClass

	^ CtCommentEditorModel! !

!CtCommentEditorMorph methodsFor: 'accessing' stamp: 'mt 3/3/2010 10:46:36'!
commentField

	commentField ifNil: [commentField := PluggableTextMorph
		on: self model
		text: #comment
		accept: #comment:.
		commentField
			useRoundedCorners;
			borderWidth: 0;
			fillStyle: (Color white alpha: 0.5);
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			cellInset: 0;
			layoutInset: 0].
	^ commentField! !

!CtCommentEditorMorph methodsFor: 'accessing' stamp: 'mt 3/3/2010 10:45:46'!
delete

	self commentField accept.
	super delete.! !

!CtCommentEditorMorph methodsFor: 'initialization' stamp: 'mt 4/14/2010 16:50:16.899'!
initializeUserInterface

	self
		addMorphBack: (SwaRowPanel for: {
			self title.
			self closeButton});
		addMorphBack: self commentField.! !

BorderedMorph subclass: #CtRowMorph
	instanceVariableNames: 'lastPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Kernel'!

!CtRowMorph class methodsFor: 'as yet unclassified' stamp: 'mt 5/1/2009 17:18'!
for: someMorphs

	| instance |
	instance := self new.
	someMorphs do: [:m | instance addMorphBack: m].
	^ instance! !

!CtRowMorph methodsFor: 'accessing' stamp: 'mt 3/3/2010 16:07:05'!
initialize

	super initialize.
	self
		changeTableLayout;
		listDirection: #leftToRight;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		layoutInset: 3;
		useRoundedCorners;
		cellInset: 3;
		borderWidth: 0;
		color: (Color r: 4 g: 133 b: 157 alpha: 0.9).! !

!CtRowMorph methodsFor: 'accessing' stamp: 'mt 5/2/2009 14:12'!
position: aPoint

	aPoint = lastPosition ifTrue: [^ self].
	lastPosition := aPoint.
	super position: aPoint.! !

!OBSystemBrowser class methodsFor: '*codetalk' stamp: 'mig 5/27/2010 18:45:39.093'!
panels

	^ {
		self mercuryPanel.
		self navigationPanel.
		self optionalButtonPanel.
		self annotationPanel.
		self toolbarPanel.
		self definitionPanel.
	} reject: [:ea | ea isNil]
! !

!OBSystemBrowser class methodsFor: '*codetalk' stamp: 'mt 3/19/2010 11:35:24.777'!
toolbarPanel

	^ (Preferences
		preferenceAt: #showCodeTalkToolbar
		ifAbsent: [Preference new rawValue: false])
		preferenceValue
			ifTrue: [CtToolbar new]
			ifFalse: []! !

SHTextStylerST80 subclass: #CtTextStyler
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Kernel'!

!CtTextStyler methodsFor: 'private' stamp: 'mt 1/17/2010 13:30'!
setAttributesIn: aText fromRanges: ranges
	"CodeTalk: Reimplemented due to strange interpretation of #shoutShouldPreserve."

	| charAttr defaultAttr attr newRuns newValues lastAttr oldRuns lastCount | 		
		
	oldRuns := aText runs.
	defaultAttr := self attributesFor: #default.
	charAttr := Array new: aText size.
	1 to: charAttr size do: [:i | charAttr at: i put: defaultAttr].
	ranges do: [:range |
		(attr := self attributesFor: range type) == nil
			ifFalse:[	range start to: range end do: [:i | charAttr at: i put: attr]]].
	newRuns := OrderedCollection new: charAttr size // 10.
	newValues := OrderedCollection new: charAttr size // 10.
	1 to: charAttr size do: [:i |
		attr := charAttr at: i.
		i = 1 
			ifTrue: [
				newRuns add: 1.
				lastCount := 1.
				lastAttr := newValues add: attr]
			ifFalse:[
				attr == lastAttr
					ifTrue: [
						lastCount := lastCount + 1.
						newRuns at: newRuns size put: lastCount]
					ifFalse: [
						newRuns add: 1.
						lastCount := 1.
						lastAttr := newValues add: attr]]].	
	aText runs: (RunArray runs: newRuns values: newValues).
	oldRuns withStartStopAndValueDo:[:start :stop :attribs|
		attribs do: [:eachAttrib | eachAttrib shoutShouldPreserve
			ifTrue: [aText addAttribute: eachAttrib from: start to: stop]]].
	! !

!CtTextStyler methodsFor: 'converting' stamp: 'mig 6/7/2010 00:02:22.454'!
unstyledTextFrom: aText
	"Avoid to write custom attributes into the changes file."

	(text attributesOfKind: CtMorphAttribute) do: [:attr | attr cleanUp].
		
	^ super unstyledTextFrom: aText.
! !

TextAttribute subclass: #CtTextAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Attributes'!

!CtTextAttribute commentStamp: 'mt 1/16/2010 16:47' prior: 0!
I am a text attribute that is capable of displaying itself in some bounds.!

CtTextAttribute subclass: #CtMorphAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Attributes'!

!CtMorphAttribute commentStamp: 'mt 1/16/2010 16:59' prior: 0!
I am a CodeTalk text attribute that contains a morph which will be displayed inline.!

CtMorphAttribute subclass: #CtIconBarAttribute
	instanceVariableNames: 'chatMorph deleteMorph resizeMorph morph commentMorph mode reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Attributes'!

!CtIconBarAttribute class methodsFor: 'as yet unclassified' stamp: 'mt 1/16/2010 19:08'!
forReference: aReferenceAttribute

	^ self new
		reference: aReferenceAttribute! !

!CtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 19:14'!
chatMorph

	^ chatMorph ifNil: [chatMorph := CtChatIconMorph new attribute: self reference]! !

!CtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 19:14'!
commentMorph

	^ commentMorph ifNil: [commentMorph := CtCommentIconMorph new attribute: self reference]! !

!CtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 19:09'!
deleteMorph

	^ deleteMorph ifNil: [deleteMorph := CtDeleteIconMorph new attribute: self reference]! !

!CtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/22/2010 11:07:51'!
iconMorphs

	^ {self chatMorph. self commentMorph. self deleteMorph. self resizeMorph}! !

!CtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 18:00'!
mode

	^ mode! !

!CtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/17/2010 17:05'!
mode: anObject

	mode := anObject.
	morph := nil.! !

!CtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 18:01'!
morph

	morph ifNil: [morph := CtRowMorph for: {
		self mode = #comment
			ifTrue: [self commentMorph]
			ifFalse: [self chatMorph].
		self resizeMorph.
		self deleteMorph}].
	^ morph! !

!CtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 19:07'!
reference

	^ reference! !

!CtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/17/2010 16:16'!
reference: aReferenceAttribute

	reference := aReferenceAttribute.
	
	aReferenceAttribute addFriend: self.
	self mode: aReferenceAttribute markup tag.! !

!CtIconBarAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 19:09'!
resizeMorph

	^ resizeMorph ifNil: [resizeMorph := CtResizeIconMorph new attribute: self reference]! !

!CtIconBarAttribute methodsFor: 'displaying' stamp: 'mt 3/19/2010 11:27:09.027'!
updateMorphs: someAttributes start: startIndex stop: stopIndex

	((someAttributes size = 1) and: [startIndex ~= stopIndex])
		ifTrue: [self resizeMorph visible: true]
		ifFalse: [self resizeMorph visible: false].
	self morph layoutChanged.! !

!CtMorphAttribute methodsFor: 'cleanup' stamp: 'mt 1/22/2010 11:17:34'!
cleanUp

	self iconMorphs do: [:m | m cleanUp]! !

!CtMorphAttribute methodsFor: 'accessing' stamp: 'mt 1/22/2010 11:06:13'!
iconMorphs
	"Return all CtAttributeIcon instances."
	
	^ #()! !

!CtMorphAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:57'!
morph

	^ self subclassResponsibility.! !

!CtMorphAttribute methodsFor: 'displaying' stamp: 'mt 1/16/2010 17:12'!
updateMorphs: someMorphAttributes start: startIndex stop: stopIndex
	"Use the chance to change your own appearance (e.g., visibility) according to the current selection."! !

CtTextAttribute subclass: #CtReferenceAttribute
	instanceVariableNames: 'markup friends theClass selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Attributes'!

!CtReferenceAttribute commentStamp: 'mt 1/16/2010 19:10' prior: 0!
I am a reference for a markup to be used in a text.!

!CtReferenceAttribute class methodsFor: 'instance creation' stamp: 'mt 1/16/2010 19:12'!
forMarkup: aMarkup

	^ self new
		markup: aMarkup! !

!CtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 1/16/2010 19:18'!
addChatLine: aMessage

	self markup addChatLine: aMessage! !

!CtReferenceAttribute methodsFor: 'friends' stamp: 'mt 1/17/2010 14:28'!
addFriend: aTextAttribute

	self friends add: aTextAttribute.! !

!CtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 1/17/2010 13:02'!
chat

	^ self markup chat! !

!CtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 1/17/2010 13:03'!
color

	^ self markup color! !

!CtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 1/17/2010 16:16'!
comment

	^ self markup comment! !

!CtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 1/17/2010 16:17'!
comment: aString

	self markup comment: aString! !

!CtReferenceAttribute methodsFor: 'accessing' stamp: 'mt 1/17/2010 14:43'!
compiledMethod

	self theClass ifNil: [^ nil].
	self selector ifNil: [^ nil].
	^ self theClass >> self selector! !

!CtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 1/17/2010 13:03'!
creator

	^ self markup creator! !

!CtReferenceAttribute methodsFor: 'friends' stamp: 'mt 1/17/2010 14:27'!
friends
	"Friends are other text attributes that belong to this reference attribute and so should have the same range as defined in the markup."

	^ friends ifNil: [friends := OrderedCollection new]! !

!CtReferenceAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 19:11'!
markup

	^ markup! !

!CtReferenceAttribute methodsFor: 'accessing' stamp: 'mt 1/16/2010 19:11'!
markup: anObject

	markup := anObject.! !

!CtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 1/16/2010 19:15'!
read

	self markup read! !

!CtReferenceAttribute methodsFor: 'signals' stamp: 'mt 1/16/2010 19:16'!
requestDeletion

	self changed: #deleteRequested with: self.! !

!CtReferenceAttribute methodsFor: 'signals' stamp: 'mt 1/16/2010 19:16'!
requestResizing
	"No need to give us away because the pure selection in a paragraph will handle this."

	self changed: #resizeRequested.! !

!CtReferenceAttribute methodsFor: 'accessing' stamp: 'mt 1/17/2010 14:34'!
selector

	^ selector! !

!CtReferenceAttribute methodsFor: 'accessing' stamp: 'mt 1/17/2010 14:34'!
selector: anObject

	selector := anObject.! !

!CtReferenceAttribute methodsFor: 'accessing' stamp: 'mt 1/17/2010 14:33'!
theClass

	^ theClass! !

!CtReferenceAttribute methodsFor: 'accessing' stamp: 'mt 1/17/2010 14:33'!
theClass: anObject

	theClass := anObject.! !

!CtReferenceAttribute methodsFor: 'markup proxy' stamp: 'mt 1/17/2010 13:02'!
timestamp

	^ self markup timestamp! !

!CtTextAttribute methodsFor: 'testing' stamp: 'mt 1/16/2010 16:49'!
= other

	^ self == other! !

!CtTextAttribute methodsFor: 'dependents access' stamp: 'mt 1/16/2010 19:06'!
addDependent: anObject

	(self dependents includes: anObject)
		ifTrue: [^ self].
		
	^ super addDependent: anObject.! !

!CtTextAttribute methodsFor: 'html' stamp: 'mt 1/16/2010 16:48'!
closeHtmlOn: aStream 
	"put on the given stream the tag to close the html  
	representation of the receiver"
	aStream nextPutAll: '</span>'! !

!CtTextAttribute methodsFor: 'displaying' stamp: 'mt 1/16/2010 16:50'!
displayOn: aCanvas in: drawBounds
	"Invisible."! !

!CtTextAttribute methodsFor: 'html' stamp: 'mt 1/16/2010 16:48'!
openHtmlOn: aStream 
	"put on the given stream the tag to open the html  
	representation of the receiver"
	aStream nextPutAll: '<span>'! !

!CtTextAttribute methodsFor: 'styling' stamp: 'mig 6/6/2010 23:55:48.223'!
shoutShouldPreserve
	
	^ true! !

CtTextAttribute subclass: #CtTextBackgroundColor
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Attributes'!

!CtTextBackgroundColor class methodsFor: 'instance creation' stamp: 'mt 1/16/2010 17:17'!
color: aColor

	^ self new
		color: aColor! !

!CtTextBackgroundColor class methodsFor: 'constants' stamp: 'mt 1/16/2010 17:18'!
green

	^ self color: (Color green alpha: 0.4)! !

!CtTextBackgroundColor class methodsFor: 'constants' stamp: 'mt 1/16/2010 17:18'!
red

	^ self color: (Color red alpha: 0.4)! !

!CtTextBackgroundColor class methodsFor: 'constants' stamp: 'mt 1/16/2010 17:19'!
yellow

	^ self color: (Color yellow alpha: 0.4)! !

!CtTextBackgroundColor methodsFor: 'accessing' stamp: 'mt 1/16/2010 17:19'!
color

	^ color ifNil: [color := Color transparent]! !

!CtTextBackgroundColor methodsFor: 'accessing' stamp: 'mt 1/16/2010 17:16'!
color: anObject

	color := anObject.! !

!CtTextBackgroundColor methodsFor: 'displaying' stamp: 'mt 1/17/2010 13:37'!
displayOn: aCanvas in: drawBounds
	"Show some stuff on the canvas for this attribute."
	
	aCanvas
		fillRectangle: drawBounds
		color: self color.! !

OBCodeNode subclass: #CtSeparatorNode
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Nodes'!

!CtSeparatorNode class methodsFor: 'instance creation' stamp: 'mt 5/25/2009 14:15'!
text: aString

	^ self new
		text: aString! !

!CtSeparatorNode methodsFor: 'testing' stamp: 'mt 5/25/2009 14:47'!
isSeparatorNode

	^ true! !

!CtSeparatorNode methodsFor: 'public' stamp: 'mt 5/25/2009 14:48'!
name

	^ text asText allBold! !

!CtSeparatorNode methodsFor: 'accessing' stamp: 'mt 5/25/2009 14:15'!
text

	^ text! !

!CtSeparatorNode methodsFor: 'accessing' stamp: 'mt 5/25/2009 14:14'!
text: anObject

	text := anObject.! !

OBTextMorphWithShout subclass: #CtTextMorph
	instanceVariableNames: 'liveModeMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Kernel'!

!CtTextMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 5/1/2009 14:13'!
addMorph: aMorph

	(self submorphs includes: aMorph)
		ifFalse: [^ super addMorph: aMorph].
	^ aMorph! !

!CtTextMorph methodsFor: 'private' stamp: 'topa 2/13/2009 14:09'!
editorClass
	"Answer the class used to create the receiver's editor"
	
	^CtEditor! !

!CtTextMorph methodsFor: 'testing' stamp: 'mt 1/17/2010 16:54'!
hasUnacceptedEdits

	^ self editView hasUnacceptedEdits! !

!CtTextMorph methodsFor: 'initialization' stamp: 'mt 4/30/2009 10:36'!
initialize

	super initialize.
	
	(Preferences preferenceAt: #showLineNumbers ifAbsent: [Preference new rawValue: false]) preferenceValue
		ifTrue: [self leftMargin: ((Preferences standardCodeFont widthOfString: '99') * 1.7) rounded].! !

!CtTextMorph methodsFor: 'accessing' stamp: 'mt 1/17/2010 17:48'!
leftMargin: aNumber

	self margins: (aNumber@0 corner: 0@0).! !

!CtTextMorph methodsFor: 'accessing' stamp: 'mt 1/17/2010 17:46'!
liveModeMorph

	^ liveModeMorph ifNil: [
		liveModeMorph := MenuIcons ctPencilExIcon asMorph.
		liveModeMorph assureExtension balloonText: 'Live Edit Mode disabled.'.
		liveModeMorph]! !

!CtTextMorph methodsFor: 'private' stamp: 'mt 4/22/2009 20:24'!
paragraphClass
	
	^ CtParagraph! !

!CtTextMorph methodsFor: 'submorphs-add/remove' stamp: 'mt 1/17/2010 17:44'!
removeAllMorphsBut: someMorphs

	self hasUnacceptedEdits
		ifTrue: [
			self addMorph: self liveModeMorph.
			self liveModeMorph setToAdhereToEdge: #topRight.
			someMorphs add: self liveModeMorph].

	self submorphs copy do: [:m | (someMorphs includes: m)
		ifFalse: [m delete]]! !

!CtTextMorph methodsFor: 'private' stamp: 'mt 1/17/2010 14:19'!
update: aSymbol

	super update: aSymbol.
	"(aSymbol = #chatLineAdded or: [aSymbol = #commentChanged])
		ifTrue: [self hasUnacceptedEdits: true]."
	aSymbol = #resizeRequested
		ifTrue: [self editor resizeMarkup].! !

!CtTextMorph methodsFor: 'private' stamp: 'mt 1/17/2010 14:21'!
update: aSymbol with: anAttribute

	aSymbol = #deleteRequested ifTrue: [
		self editor removeMarkup: anAttribute].
	
	super update: aSymbol with: anAttribute.! !

!OBNode methodsFor: '*codetalk' stamp: 'mt 5/25/2009 14:46'!
isSeparatorNode

   ^false! !

!OBDefinitionPanel methodsFor: '*codetalk-override' stamp: 'mt 9/22/2010 15:20:42.154'!
buildOn: aBuilder
	"See OBMorphBuilder>>#textArea:."
	
	^aBuilder textarea: self! !

!OBDefinitionPanel methodsFor: '*codetalk' stamp: 'mt 3/19/2010 10:21:46.039'!
contentMorph

	^ contentMorph! !

!OBDefinitionPanel methodsFor: '*codetalk' stamp: 'mt 3/19/2010 10:22:02.84'!
contentMorph: aMorph

	contentMorph := aMorph.! !

!OBMethodNode methodsFor: '*codetalk' stamp: 'mt 5/3/2009 10:02'!
categoryText

	^ self category! !

!OBMethodNode methodsFor: '*codetalk' stamp: 'mt 5/3/2009 09:55'!
sourceText

	^ self source! !

!OBMethodNode methodsFor: '*codetalk' stamp: 'mt 1/17/2010 11:40'!
timeStamp

	^ (self theClass >> self selector) timeStamp! !

PluggableButtonMorphPlus subclass: #CtButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Morphs'!

!CtButton class methodsFor: 'instance creation' stamp: 'mt 3/3/2010 15:37:15'!
on: aModel action: actionSel icon: aSymbol label: aTextOrString

	| lm |
	lm := Morph new
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color transparent;
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 2.
		
	lm
		addMorphBack: (MenuIcons perform: aSymbol) asMorph;
		addMorphBack: aTextOrString asMorph.
		
	^ (self
		on: aModel
		getState: nil
		action: actionSel)
			hResizing: #shrinkWrap;
			vResizing: #spaceFill;
			styleWith: OBMorphBuilder new;
			"setBalloonText: aCommand longDescription;"
			cellInset: 1;	
			label: lm;
			yourself! !

!OBPluggableTextMorphWithShout class methodsFor: '*codetalk-override' stamp: 'mt 5/1/2009 15:45'!
on: anObject text: getTextSel accept: setTextSel readSelection: getSelectionSel menu: getMenuSel
	"CodeTalk: Use the XpfStyler right now."
	
	|styler answer stylerClass |
	answer := self new.
	stylerClass := answer stylerClass.
	styler := stylerClass
		ifNotNil:[
			stylerClass new
				view: answer;
				yourself].
	^ answer
		styler: styler;
		on: anObject
		text: getTextSel
		accept: setTextSel
		readSelection: getSelectionSel
		menu: getMenuSel! !

!OBPluggableTextMorphWithShout methodsFor: '*codetalk' stamp: 'topa 2/13/2009 13:48'!
stylerClass
	^CtTextStyler! !

!OBPluggableTextMorphWithShout methodsFor: '*codetalk-override' stamp: 'topa 2/13/2009 13:48'!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	^CtTextMorph! !

!OBPluggableTextMorphWithShout methodsFor: '*codetalk' stamp: 'mt 1/22/2010 13:11:15'!
update: aSymbol

	aSymbol = getTextSelector ifTrue: [
		textMorph ifNotNilDo: [:tm | (tm contents attributesOfKind: CtMorphAttribute)
			do: [:attr | attr cleanUp]]].

	super update: aSymbol.! !

OBCommand subclass: #CtEditCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Commands'!

CtEditCommand subclass: #CtCmdAddComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Commands'!

!CtCmdAddComment methodsFor: 'execution' stamp: 'mt 6/11/2009 17:43'!
execute

	self textMorph editor addComment.! !

!CtCmdAddComment methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:49'!
group

	^ '2'! !

!CtCmdAddComment methodsFor: 'accessing' stamp: 'mt 3/18/2010 18:21:41'!
icon

	^ #ctMarkGreenIcon! !

!CtCmdAddComment methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:50'!
label

	^ 'add comment'! !

CtEditCommand subclass: #CtCmdChangeTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Commands'!

!CtCmdChangeTag methodsFor: 'execution' stamp: 'mt 6/11/2009 17:42'!
execute

	self textMorph editor changeMarkupTag.! !

!CtCmdChangeTag methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:49'!
group

	^ '3'! !

!CtCmdChangeTag methodsFor: 'testing' stamp: 'mt 5/2/2010 11:27:36.109'!
isActive

	^ false! !

!CtCmdChangeTag methodsFor: 'testing' stamp: 'mt 1/17/2010 15:07'!
isEnabled

	^ target fullText
		includesAttributesOfKind: CtReferenceAttribute
		from: target start
		to: (target stop max: target start)! !

!CtCmdChangeTag methodsFor: 'accessing' stamp: 'mt 5/18/2009 10:55'!
label

	^ 'change tag'! !

CtEditCommand subclass: #CtCmdConvertInlineComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Commands'!

!CtCmdConvertInlineComment methodsFor: 'execution' stamp: 'mt 6/11/2009 17:42'!
execute

	self textMorph editor convertInlineComment: target.! !

!CtCmdConvertInlineComment methodsFor: 'accessing' stamp: 'mt 6/6/2009 11:17'!
group

	^ '2'! !

!CtCmdConvertInlineComment methodsFor: 'accessing' stamp: 'mt 6/6/2009 13:28'!
icon

	^ #ctCommentGoIcon! !

!CtCmdConvertInlineComment methodsFor: 'testing' stamp: 'mt 1/17/2010 15:07'!
isEnabled

	^ target start <= target stop
		and: [(target fullText
			includesAttributesOfKind: CtReferenceAttribute
			from: target start
			to: target stop) not]! !

!CtCmdConvertInlineComment methodsFor: 'accessing' stamp: 'mt 6/6/2009 11:17'!
label

	^ 'convert inline comment'! !

CtEditCommand subclass: #CtCmdJustTalk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Commands'!

!CtCmdJustTalk methodsFor: 'execution' stamp: 'mt 6/11/2009 17:42'!
execute

	self textMorph editor addCodeChat.! !

!CtCmdJustTalk methodsFor: 'accessing' stamp: 'mt 5/2/2009 19:20'!
group

	^ '1'! !

!CtCmdJustTalk methodsFor: 'accessing' stamp: 'mt 3/18/2010 18:21:55'!
icon

	^ #ctMarkYellowIcon! !

!CtCmdJustTalk methodsFor: 'accessing' stamp: 'mt 5/5/2009 15:38'!
keystroke

	^ $t! !

!CtCmdJustTalk methodsFor: 'accessing' stamp: 'mt 5/5/2009 21:47'!
label

	^ 'add code chat'! !

CtEditCommand subclass: #CtCmdMarkBad
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Commands'!

!CtCmdMarkBad methodsFor: 'editor-bridge' stamp: 'mt 6/11/2009 17:43'!
execute

	self textMorph editor markAsBad.! !

!CtCmdMarkBad methodsFor: 'accessing' stamp: 'mt 5/5/2009 15:00'!
group

	^ '1'! !

!CtCmdMarkBad methodsFor: 'accessing' stamp: 'mt 3/18/2010 18:20:39'!
icon

	^ #ctMarkRedIcon! !

!CtCmdMarkBad methodsFor: 'accessing' stamp: 'mt 5/5/2009 15:38'!
keystroke

	^ $r! !

!CtCmdMarkBad methodsFor: 'accessing' stamp: 'mfp 2/3/2009 16:11'!
label
	^ 'mark bad'! !

CtEditCommand subclass: #CtCmdMarkForRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Commands'!

!CtCmdMarkForRefactoring methodsFor: 'editor-bridge' stamp: 'bs 12/15/2009 13:06'!
execute

	self textMorph editor markForRefactoring.! !

!CtCmdMarkForRefactoring methodsFor: 'accessing' stamp: 'bs 12/15/2009 13:07'!
group

	^ '2'! !

!CtCmdMarkForRefactoring methodsFor: 'accessing' stamp: 'mt 3/18/2010 18:20:43'!
icon

	^ #ctMarkRedIcon! !

!CtCmdMarkForRefactoring methodsFor: 'accessing' stamp: 'bs 12/15/2009 13:05'!
label
	^ 'mark for refactoring'! !

CtEditCommand subclass: #CtCmdRemoveMarkup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Commands'!

!CtCmdRemoveMarkup methodsFor: 'execution' stamp: 'mt 6/11/2009 17:43'!
execute
	
	self textMorph editor removeMarkup.! !

!CtCmdRemoveMarkup methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:49'!
group

	^ '3'! !

!CtCmdRemoveMarkup methodsFor: 'accessing' stamp: 'mt 5/2/2009 19:23'!
icon

	^ #ctDeleteIcon! !

!CtCmdRemoveMarkup methodsFor: 'testing' stamp: 'mt 1/17/2010 15:07'!
isEnabled

	^ target fullText
		includesAttributesOfKind: CtReferenceAttribute
		from: target start
		to: (target stop max: target start)! !

!CtCmdRemoveMarkup methodsFor: 'accessing' stamp: 'mt 5/3/2009 19:06'!
label

	^'remove markup'! !

CtEditCommand subclass: #CtCmdResize
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Commands'!

!CtCmdResize methodsFor: 'execution' stamp: 'mt 6/11/2009 17:43'!
execute
	
	self textMorph editor resizeMarkup.! !

!CtCmdResize methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:49'!
group

	^ '3'! !

!CtCmdResize methodsFor: 'testing' stamp: 'mt 5/3/2009 19:17'!
icon

	^ #ctPaintcanIcon! !

!CtCmdResize methodsFor: 'testing' stamp: 'mt 1/17/2010 15:07'!
isEnabled

	^ target start <= target stop
		and: [(target fullText
			attributesOfKind: CtReferenceAttribute
			from: target start
			to: target stop) size = 1]! !

!CtCmdResize methodsFor: 'accessing' stamp: 'mt 5/3/2009 19:06'!
label

	^'resize markup'! !

!CtEditCommand class methodsFor: 'testing' stamp: 'cs 5/2/2009 13:30'!
takesText

	^ true! !

!CtEditCommand methodsFor: 'accessing' stamp: 'cs 5/2/2009 13:31'!
cluster

	^ #CodeTalk! !

!CtEditCommand methodsFor: 'testing' stamp: 'mt 6/23/2009 08:59'!
isActive

	^ target isKindOf: OBTextSelection! !

!CtEditCommand methodsFor: 'testing' stamp: 'mt 1/17/2010 15:07'!
isEnabled

	^ target stop >= target start
		and: [(target fullText
			includesAttributesOfKind: CtReferenceAttribute
			from: target start
			to: target stop) not]! !

!CtEditCommand methodsFor: 'execution' stamp: 'mt 6/23/2009 09:52'!
textMorph
	"The requestor has to be an OBEnhancementDefinitionPanel"
	
	^ requestor contentMorph textMorph! !

MultiNewParagraph subclass: #CtParagraph
	instanceVariableNames: 'textMorph showLineNumbers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Kernel'!

!CtParagraph methodsFor: 'displaying-morphs' stamp: 'mt 1/16/2010 17:01'!
addAttributeMorphs
	"Add the small iconmorphs that appear for some attributes in the text."
	
	| morphs |
	self selectionStart isNil | self textMorph isNil
		ifTrue: [^ self].

	morphs := (self text
		attributesOfKind: CtMorphAttribute 
		from: self selectionStart stringIndex
		to: ((self selectionStop stringIndex - 1) max: self selectionStart stringIndex))
		collect: [:attr | self textMorph addMorph: attr morph. attr morph].
	self textMorph removeAllMorphsBut: morphs.! !

!CtParagraph methodsFor: 'displaying' stamp: 'mt 1/16/2010 17:00'!
displayOn: aCanvas using: displayScanner at: somePosition

	self
		updateProperties;
		addAttributeMorphs;
		updateAttributeMorphs;
		drawLineNumberBorderOn: aCanvas.
	
	(self lineIndexForPoint: aCanvas clipRect topLeft)
		to: (self lineIndexForPoint: aCanvas clipRect bottomRight)
		do: [ :i |
			self drawTextAttributeOn: aCanvas at: i.
			self drawLineNumber: i on: aCanvas for: (lines at: i)].
	
	super displayOn: aCanvas using: displayScanner at: somePosition.! !

!CtParagraph methodsFor: 'displaying' stamp: 'mt 5/1/2009 16:15'!
drawLineNumber: aNumber on: aCanvas for: line

	| str |
	showLineNumbers ifFalse: [^ self].
	self textMorph ifNil: [^ self].
	
	str := (aNumber < 10 ifTrue: [' '] ifFalse: ['']), aNumber asString.
	aCanvas
		drawString: str
		from: 1
		to: str size
		at: (self textMorph position x @ (line top + 2))
		font: Preferences standardCodeFont
		color: ((self isInSelectionFor: line)
			ifTrue: [Color black]
			ifFalse: [Color gray]).! !

!CtParagraph methodsFor: 'displaying' stamp: 'mt 5/1/2009 16:12'!
drawLineNumberBorderOn: aCanvas

	| fontWidth |
	showLineNumbers ifFalse: [^ self].
	self textMorph ifNil: [^ self].
	
	fontWidth := Preferences standardCodeFont widthOfString: '99'.
	aCanvas
		line: (self textMorph position x + fontWidth + 3) @ aCanvas clipRect top
		to: (self textMorph position x + fontWidth + 3) @ aCanvas clipRect bottom
		width: 1
		color: Color gray.! !

!CtParagraph methodsFor: 'displaying' stamp: 'mt 1/17/2010 14:09'!
drawTextAttributeOn: aCanvas at: index 

	| textLine line nextLine|
	line := lines at: index.
	nextLine := lines size > index ifTrue: [lines at: index + 1] ifFalse: [].
	textLine := self text 
		copyFrom: line first
		to: line last.
	textLine runs withStartStopAndValueDo: [:start :stop :attributes |
		attributes 
			select: [:attr | attr isKindOf: CtTextAttribute]
			thenDo: [:attr | | cb1 cb2 |
				cb1 := self characterBlockForIndex: start + (line first - 1).
				cb2 := self characterBlockForIndex: stop + (line first - 1).
	
				"Highlight the attribute."
				attr
					displayOn: aCanvas
					in: (cb1 left @ line top corner: cb2 right @ line bottom).

				(attr isKindOf: CtMorphAttribute) ifTrue: [
					"Update position of the morph from the attribute."
					(self isLastOccuranceOf: attr in: textLine position: stop for: index)
						ifTrue: [self
							moveAttributeMorph: attr morph
							to: cb2 right @ (line top - attr morph height)]]]
				].! !

!CtParagraph methodsFor: 'testing' stamp: 'mt 7/2/2009 21:42'!
isInSelectionFor: line

	(self selectionStart isNil or: [self selectionStop isNil])
		ifTrue: [^ false].
		
	^ line last >= self selectionStart textLine first
		and: [line first <= self selectionStop textLine last]! !

!CtParagraph methodsFor: 'testing' stamp: 'mt 5/1/2009 15:31'!
isLastOccuranceOf: cAttr in: textLine position: endOfRunIndex for: lineIndex
	"Answer true if the attribute does not appear in another run past the current one."

	| nextLine |
	nextLine := lines size > lineIndex ifTrue: [lines at: lineIndex + 1] ifFalse: [].
	^ ((nextLine isNil
		or: [((self text attributesAt: nextLine first) noneSatisfy: [:att | att == cAttr])])
		and: [textLine runs size < (endOfRunIndex + 1) 
			or: [(textLine attributesAt: endOfRunIndex + 1)	noneSatisfy: [:att | att == cAttr]]])! !

!CtParagraph methodsFor: 'displaying-morphs' stamp: 'mt 5/3/2009 13:53'!
moveAttributeMorph: aMorph to: aPosition
	"Used to display small morphs to interaction with the markup. Pay attention to the extent of the textMorph if possible."
	
	| pos |
	pos := aPosition.
	self textMorph ifNotNilDo: [:t |
		pos := (t extent x - aMorph width min: aPosition x)
			@ (aPosition y < -5 ifTrue: [aMorph height max: aPosition y] ifFalse: [aPosition y])].
	aMorph position: pos.! !

!CtParagraph methodsFor: 'accessing' stamp: 'mt 4/22/2009 20:37'!
textMorph
	^ textMorph! !

!CtParagraph methodsFor: 'accessing' stamp: 'mt 4/22/2009 20:37'!
textMorph: anObject
	textMorph := anObject! !

!CtParagraph methodsFor: 'displaying-morphs' stamp: 'mt 1/16/2010 17:12'!
updateAttributeMorphs
	
	| attrs |
	self selectionStart isNil | self textMorph isNil
		ifTrue: [^ self].
	
	attrs := self text
		attributesOfKind: CtMorphAttribute 
		from: self selectionStart stringIndex
		to: ((self selectionStop stringIndex - 1) max: self selectionStart stringIndex).

	attrs do: [:attr | attr
		updateMorphs: attrs
		start: self selectionStart stringIndex
		stop: self selectionStop stringIndex].! !

!CtParagraph methodsFor: 'accessing' stamp: 'mt 5/1/2009 16:16'!
updateProperties

	showLineNumbers ifNil: [showLineNumbers := 
		(Preferences
			preferenceAt: #showLineNumbers
			ifAbsent: [Preference new rawValue: false])
			preferenceValue].! !

!SHParserST80 methodsFor: '*codetalk' stamp: 'mt 6/6/2009 13:02'!
parseSource: aString
	"Parse the source of a method."

	self
		source: aString;
		parse: true.
	^ ranges! !

PluggableTextMorph subclass: #CtChatLog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Morphs'!

!CtChatLog methodsFor: 'initialization' stamp: 'mt 5/2/2010 14:29:30.586'!
initialize

	super initialize.
	self
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		cellInset: 0;
		layoutInset: 0;
		borderWidth: 0;
		fillStyle: Color white;
		setText: 'Foobar'.! !

OBPanel subclass: #CtToolbar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Panels'!

!CtToolbar methodsFor: 'actions' stamp: 'mt 6/11/2009 17:47'!
addChat
	
	self textMorph editor addCodeChat.! !

!CtToolbar methodsFor: 'actions' stamp: 'mt 3/18/2010 18:24:17'!
addChatLabel
	
	^ self
		labelMorphWithIcon: MenuIcons ctMarkYellowSmallIcon
		text: 'add code chat'! !

!CtToolbar methodsFor: 'actions' stamp: 'mt 6/11/2009 17:47'!
addComment
	
	self textMorph editor addComment.! !

!CtToolbar methodsFor: 'actions' stamp: 'mt 3/18/2010 18:22:54'!
addCommentLabel
	
	^ self
		labelMorphWithIcon: MenuIcons ctMarkGreenSmallIcon
		text: 'add comment'! !

!CtToolbar methodsFor: 'building' stamp: 'mt 3/3/2010 15:38:20'!
buildOn: aMorphBuilder

	| row head |
	head := 'CodeTalk' asText.
	head addAttribute: (TextColor color: Color gray)
        ";FIXME: fonts
	head addAttribute: (TextFontReference toFont: (CtFontProvider sansFontAt: 8))".
	row := Morph new
		changeTableLayout;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		listDirection: #leftToRight;
		borderWidth: 1;
		"borderRaised;"
		cellInset: 5;
		fillStyle: (Color r: 0.8 g: 0.8 b: 0.8 alpha: 0.5);
		addMorphBack: (Morph new vResizing: #rigid; hResizing: #rigid; fillStyle: Color transparent; extent: 3@3);
		addMorphBack: head asMorph;
		addMorphBack: self dot;
		addMorphBack: (self newButton: #addComment);
		addMorphBack: (self newButton: #addChat);
		addMorphBack: (self newButton: #markBad);
		addMorphBack: self dot;
		addMorphBack: (self newButton: #convertInlineComment).
"		addMorphBack: self dot;
		addMorphBack: (self newButton: #markForRefactoring).
"	
	aMorphBuilder insertMorph: row.! !

!CtToolbar methodsFor: 'actions' stamp: 'mt 6/11/2009 17:48'!
convertInlineComment
	
	self textMorph editor convertInlineComment.! !

!CtToolbar methodsFor: 'actions' stamp: 'mt 6/6/2009 13:35'!
convertInlineCommentLabel
	
	^ self
		labelMorphWithIcon: MenuIcons ctCommentGoIcon
		text: 'convert inline comment'! !

!CtToolbar methodsFor: 'building' stamp: 'mt 3/19/2010 11:35:42.935'!
dot

	^ Morph new
		hResizing: #rigid;
		vResizing: #rigid;
		fillStyle: Color gray;
		extent: 2@2! !

!CtToolbar methodsFor: 'building' stamp: 'mt 3/19/2010 11:35:54.748'!
labelMorphWithIcon: anIcon text: aString

	| lm lbl |

	lm := Morph new
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 4.
	
	lbl := aString asText.
	lbl
		"addAttribute: (TextColor color: Color gray muchDarker);"
                "FIXME: fonts
		addAttribute: (TextFontReference toFont: (CtFontProvider sansFontAt: 8))".
		
	lm
		addMorphBack: anIcon asMorph;
		addMorphBack: lbl asMorph lock.

	^ lm! !

!CtToolbar methodsFor: 'actions' stamp: 'mt 6/11/2009 17:48'!
markBad
	
	self textMorph editor markAsBad.! !

!CtToolbar methodsFor: 'actions' stamp: 'mt 3/18/2010 18:23:40'!
markBadLabel

	^ self
		labelMorphWithIcon: MenuIcons ctMarkRedSmallIcon
		text: 'mark bad'! !

!CtToolbar methodsFor: 'actions' stamp: 'bs 12/15/2009 13:12'!
markForRefactoring
	
	self textMorph editor markForRefactoring.! !

!CtToolbar methodsFor: 'actions' stamp: 'mt 3/18/2010 18:23:47'!
markForRefactoringLabel

	^ self
		labelMorphWithIcon: MenuIcons ctMarkRedSmallIcon
		text: 'mark for refactoring'! !

!CtToolbar methodsFor: 'building' stamp: 'mt 5/30/2009 19:49'!
newButton: aSymbol

	^ (PluggableButtonMorphPlus
		on: self
		getState: nil
		action: aSymbol
		label: (aSymbol, #Label) asSymbol)
		borderWidth: 0;
		height: 16;
		onColor: Color white offColor: Color gray muchLighter.! !

!CtToolbar methodsFor: 'private' stamp: 'mt 6/23/2009 09:57'!
textMorph
	"Definition panel should be an OBEnhancementDefinitionPanel."
	
	^ self browser definitionPanel contentMorph textMorph! !

!CtToolbar methodsFor: 'private' stamp: 'mt 5/30/2009 18:38'!
vResizing

	^ #rigid! !

Object subclass: #CtClassRecord
	instanceVariableNames: 'theClassName methodRecords'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Database'!

!CtClassRecord commentStamp: 'mt 1/16/2010 11:43' prior: 0!
I am a container for class markups and method records.!

!CtClassRecord class methodsFor: 'instance creation' stamp: 'mt 1/16/2010 15:07'!
newFrom: aClassOrMetaClass

	^ self new
		theClassName: aClassOrMetaClass name! !

!CtClassRecord methodsFor: 'query - records' stamp: 'mt 1/16/2010 12:19'!
at: aSelector

	^ self methodRecords
		at: aSelector
		ifAbsent: [(self theClass canUnderstand: aSelector)
			ifTrue: [self methodRecords at: aSelector put:
				(CtMethodRecord newFrom: self theClass >> aSelector)]]
	! !

!CtClassRecord methodsFor: 'query - records' stamp: 'mt 1/16/2010 15:29'!
includes: aSelector

	^ self methodRecords
		includesKey: aSelector
! !

!CtClassRecord methodsFor: 'accessing' stamp: 'mt 1/16/2010 12:03'!
methodRecords
	"Key: Selector (ByteSymbol), Value: Method Record (CtMethodRecord)"

	^ methodRecords ifNil: [methodRecords := Dictionary new]! !

!CtClassRecord methodsFor: 'query - environment' stamp: 'mt 1/16/2010 12:06'!
theClass

	^ self theClassName
		ifNotNilDo: [:name | Smalltalk classNamed: name]! !

!CtClassRecord methodsFor: 'accessing' stamp: 'mt 1/16/2010 11:58'!
theClassName

	^ theClassName! !

!CtClassRecord methodsFor: 'accessing' stamp: 'mt 1/16/2010 11:58'!
theClassName: anObject

	theClassName := anObject.! !

Object subclass: #CtCodeChatModel
	instanceVariableNames: 'attribute searchString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Models'!

!CtCodeChatModel methodsFor: 'adding' stamp: 'mt 3/2/2010 11:48:17'!
addMessage: aMessage

	aMessage ifEmpty: [^ self].
	self attribute ifNil: [^ self].
	self attribute addChatLine: aMessage.
	self
		changed: #messages;
		changed: #newMessage;
		changed: #hasMessages.! !

!CtCodeChatModel methodsFor: 'accessing' stamp: 'mt 4/29/2009 22:22'!
attribute

	^ attribute! !

!CtCodeChatModel methodsFor: 'accessing' stamp: 'mt 4/29/2009 22:22'!
attribute: anXpfComplexAttribute

	attribute := anXpfComplexAttribute.
	self changed: #messages.! !

!CtCodeChatModel methodsFor: 'accessing' stamp: 'mt 5/3/2009 14:14'!
hasMessages

	^ self attribute notNil and: [self attribute chat isEmpty not].! !

!CtCodeChatModel methodsFor: 'adding' stamp: 'mt 3/2/2010 11:58:09'!
highlight: aText ifMatch: aString
	"Change backgroundcolor if the string is in the message."
	
"	(aText asString asLowercase includesSubString: aString asLowercase)
		ifTrue: [self color: Color yellow]."! !

!CtCodeChatModel methodsFor: 'accessing' stamp: 'mt 3/2/2010 11:58:33'!
messages

	self attribute ifNil: [^ '' asText].
	
	^ self attribute chat
		inject: Text new
		into: [:result :line |
			| author timestamp message entry |
			author := (line at: #author) asText.
			author
				addAttribute: TextEmphasis bold
				";FIXME: fonts
                                addAttribute: (TextFontReference toFont: (CtFontProvider sansFontAt: 8))".
			timestamp := (line at: #timestamp) printRelativeTimeStamp asText.
			timestamp
				addAttribute: TextColor gray
                                ";FIXME: fonts
				addAttribute: (TextFontReference toFont: (CtFontProvider sansFontAt: 8))".
			message := (line at: #message) asText.
			message addAttribute: (TextIndent amount: 1).
			CtMethodLink addMethodLinksInto: message.
			CtLoader highlightAuthorInitialsFor: message.
			self highlight: message ifMatch: self searchString.
			
			result
				append: author;
				append: '  ';
				append: timestamp;
				append: String cr;
				append: message;
				append: String cr.
			].! !

!CtCodeChatModel methodsFor: 'accessing' stamp: 'mt 5/1/2009 18:07'!
newMessage

	^ ''! !

!CtCodeChatModel methodsFor: 'accessing' stamp: 'mt 5/3/2009 13:58'!
searchString

	searchString ifNil: [searchString := ''].
	^ searchString! !

!CtCodeChatModel methodsFor: 'accessing' stamp: 'mt 5/3/2009 14:21'!
searchString: aString

	searchString := aString.
	self changed: #messages.! !

Object subclass: #CtCommentEditorModel
	instanceVariableNames: 'attribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Models'!

!CtCommentEditorModel methodsFor: 'accessing' stamp: 'mt 5/28/2009 19:36'!
attribute

	^ attribute! !

!CtCommentEditorModel methodsFor: 'accessing' stamp: 'mt 5/28/2009 20:07'!
attribute: anObject

	attribute := anObject.
	self changed: #comment.! !

!CtCommentEditorModel methodsFor: 'accessing' stamp: 'mt 6/5/2009 13:43'!
comment

	self attribute ifNil: [^ ''].
	^ CtMethodLink addMethodLinksInto: self attribute comment asText! !

!CtCommentEditorModel methodsFor: 'accessing' stamp: 'mt 5/28/2009 20:03'!
comment: aString

	self attribute comment: aString.! !

Object subclass: #CtLoader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Kernel'!

!CtLoader commentStamp: 'mt 3/2/2010 10:51:58' prior: 0!
This class is only for general CodeTalk initialization purposes. See the class-side methods.!

!CtLoader class methodsFor: 'services' stamp: 'mt 3/2/2010 11:53:56'!
highlightAuthorInitialsFor: aText
	"Look for this image's author initials and highlight them. This will modify the attributse of the given text."
	
	| rx s strm links |
	rx := ('\\<{1}\\>' format: {Utilities authorInitials}) asRegex.
	s := aText asString.
	strm := s readStream.
	links := OrderedCollection new.
	
	[rx searchStream: strm]
		whileTrue: [
			links add: {
				rx subBeginning: 1.
				rx subEnd: 1}].

	links do: [:link |
		aText
			addAttribute: (TextColor color: Color green muchDarker)
			from: link first + 1
			to: link second.
		aText
			addAttribute: TextEmphasis bold
			from: link first + 1
			to: link second].
		
	^ aText! !

!CtLoader class methodsFor: 'initialization' stamp: 'mig 6/20/2010 15:37:18.428'!
initialize
	"Resend this message whenever you checkout a new version of CodeTalk."
	
	super initialize.
	self
		initializePreferences;
		initializeOtherClasses.! !

!CtLoader class methodsFor: 'initialization' stamp: 'mt 4/29/2010 10:08:20.871'!
initializeOtherClasses
	
	(Smalltalk includesKey: #CtEditor)
		ifTrue: [CtEditor initializeCmdKeyShortcuts].
		
	(Smalltalk includesKey: #CtMarkup)
		ifTrue: [CtMarkup reset].
		
	((Smalltalk includesKey: #SwaSourceTextStyler)
	and: [(Smalltalk includesKey: #CtSourceTextStyler)])
		ifTrue: [SwaSourceTextStyler instance registeredStylers
			detect: [:styler | styler isKindOf: CtSourceTextStyler]
			ifNone: [SwaSourceTextStyler instance registerStyler: (CtSourceTextStyler new)]].
		
	(OBDefinitionPanel allInstVarNames includes: #contentMorph)
		ifFalse:[OBDefinitionPanel addInstVarName: #contentMorph].! !

!CtLoader class methodsFor: 'initialization' stamp: 'mig 6/20/2010 15:37:49.536'!
initializePreferences
		
	(Preferences dictionaryOfPreferences includesKey: #showLineNumbers)
		ifFalse: [Preferences
			addBooleanPreference: #showLineNumbers
			category: #CodeTalk
			default: false
			balloonHelp: 'Enables line numbers in front of each codeline.'].
		
	(Preferences dictionaryOfPreferences includesKey: #showProtocolForMessage)
		ifFalse: [Preferences
			addBooleanPreference: #showProtocolForMessage
			category: #CodeTalk
			default: false
			balloonHelp: 'Displays the protocol name after each message name in the code browser.'].
		
	(Preferences dictionaryOfPreferences includesKey: #showCodeTalkToolbar)
		ifFalse: [Preferences
			addBooleanPreference: #showCodeTalkToolbar
			category: #CodeTalk
			default: true
			balloonHelp: 'Show a convenient toolbar for markups in the package browser.'].
		
	(Preferences dictionaryOfPreferences includesKey: #rememberMarkupReads)
		ifFalse: [Preferences
			addBooleanPreference: #rememberMarkupReads
			category: #CodeTalk
			default: true
			balloonHelp: 'Shows markups differently in markup browser that have been already read.'].

	Preferences setPreference: #confirmFirstUseOfStyle toValue: false.
	Preferences setPreference: #alwaysShowVScrollbar toValue: false.! !

Object subclass: #CtMarkup
	instanceVariableNames: 'tag chat creator timestamp comment range'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Database'!

CtMarkup class
	instanceVariableNames: 'colorTable readCache'!

CtMarkup class
	instanceVariableNames: 'colorTable readCache'!

!CtMarkup class methodsFor: 'color mapping' stamp: 'mt 1/16/2010 16:17'!
colorForTag: aSymbol

	colorTable ifNil: [colorTable := Dictionary newFrom: {
		#bad -> (Color red alpha: 0.4).
		#talk -> (Color yellow alpha: 0.4).
		#comment -> (Color green alpha: 0.4)}].
	
	^ colorTable at: aSymbol ifAbsent: [Color transparent]! !

!CtMarkup class methodsFor: 'instance creation' stamp: 'mt 1/16/2010 16:17'!
forTag: aSymbol

	^ self new
		tag: aSymbol;
		timestamp: TimeStamp now;
		creator: Utilities authorInitials! !

!CtMarkup class methodsFor: 'legacy' stamp: 'mt 1/16/2010 16:25'!
newFromComplexAttribute: aComplexAttribute

	^ (self forTag: aComplexAttribute tag)
		chat: aComplexAttribute chat;
		creator: aComplexAttribute creator;
		timestamp: aComplexAttribute timestamp;
		comment: aComplexAttribute comment! !

!CtMarkup class methodsFor: 'caching' stamp: 'mt 1/16/2010 16:14'!
read: aComplexAttribute
	"Tell the local cache that the given attribute was read by the developer."
	
	(Preferences
		preferenceAt: #rememberMarkupReads
		ifAbsent: [Preference new rawValue: false])
		preferenceValue
			ifFalse: [^ self].
	
	(readCache ifNil: [readCache := Set new])
		add: (self uniqueArrayFor: aComplexAttribute).! !

!CtMarkup class methodsFor: 'caching' stamp: 'mt 1/16/2010 16:14'!
reset
	"Free all cached values."
	
	colorTable := nil.
	readCache := nil.! !

!CtMarkup class methodsFor: 'caching' stamp: 'mt 1/16/2010 16:14'!
tags
	"Return a list of all available tags."

	^ #(bad talk comment)! !

!CtMarkup class methodsFor: 'caching' stamp: 'mt 1/17/2010 19:42'!
uniqueArrayFor: aMarkup
	
	^ {	aMarkup creator.
		aMarkup timestamp printString.
		aMarkup chat isEmpty
			ifTrue: ['']
			ifFalse: [aMarkup chat last at: #author].
		aMarkup chat isEmpty
			ifTrue: ['']
			ifFalse: [(aMarkup chat last at: #timestamp) printString].
		aMarkup tag.
		aMarkup comment.
		aMarkup range asString}.! !

!CtMarkup class methodsFor: 'caching' stamp: 'mt 5/2/2010 11:39:36.388'!
wasRead: aMarkup
	"Did the developer already read the given attribute?"
	
	(Preferences
		preferenceAt: #rememberMarkupReads
		ifAbsent: [Preference new rawValue: false])
		preferenceValue
			ifFalse: [readCache := nil. ^ false].
	
	^ (readCache ifNil: [readCache := Set new])
		includes: (self uniqueArrayFor: aMarkup)! !

!CtMarkup methodsFor: 'chat' stamp: 'mt 3/3/2010 10:19:51'!
addChatLine: aString

	self chat add: (Dictionary newFrom: {
		#author -> Utilities authorInitials.
		#timestamp -> TimeStamp now.
		#message -> aString asString withBlanksTrimmed}).! !

!CtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:03'!
chat

	^ chat ifNil: [chat := OrderedCollection new]! !

!CtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:04'!
chat: aCollection

	chat := aCollection.! !

!CtMarkup methodsFor: 'copying' stamp: 'test 1/16/2010 16:36'!
clone
	
	^ self deepCopy "Does this work as expected?"! !

!CtMarkup methodsFor: 'reading' stamp: 'mt 5/2/2010 11:34:23.196'!
codeSnippetFor: aString
	"Return the code snippet that is marked by this markup."
	
	self range last > aString size
		ifTrue: [^ '(bad range)'].
	
	^ (aString asString
		copyFrom: self range first
		to: self range last) withBlanksTrimmed! !

!CtMarkup methodsFor: 'accessing read-only' stamp: 'mt 1/16/2010 16:11'!
color

	^ self class colorForTag: self tag! !

!CtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:04'!
comment

	^ comment ifNil: [comment := '']! !

!CtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:08'!
comment: aString

	comment := aString asString withBlanksTrimmed.! !

!CtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:08'!
creator

	creator ifNil: [creator := 'n/a'. Transcript show: '[CodeTalk] Attribute without author detected!!'; cr].
	^ creator! !

!CtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:08'!
creator: authorInitials

	creator := authorInitials.! !

!CtMarkup methodsFor: 'accessing' stamp: 'mig 6/7/2010 19:59:15.946'!
includesChatLine: aString

	^ self chat anySatisfy: [:dict |
		((dict at: #message) includesSubString: aString)]
! !

!CtMarkup methodsFor: 'chat' stamp: 'mt 1/16/2010 16:12'!
isAuthorMentioned
	"Look into the chat messages to find out if this image's author is mentioned in a message."
	
	| rx |
	rx := ('\\<{1}\\>' format: {Utilities authorInitials}) asRegex.
	^ self chat anySatisfy: [:line | rx search: (line at: #message)]! !

!CtMarkup methodsFor: 'testing' stamp: 'mt 1/17/2010 11:07'!
isGlobal
	"Check whether this markup applies only to a range or the whole subject."
	
	^ self range first > self range last! !

!CtMarkup methodsFor: 'testing' stamp: 'mt 1/16/2010 16:13'!
isMine

	^ self creator = Utilities authorInitials! !

!CtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 19:49'!
range

	^ range ifNil: [range := 0 to: -1]! !

!CtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:33'!
range: aPoint

	range := aPoint! !

!CtMarkup methodsFor: 'reading' stamp: 'mt 1/16/2010 16:13'!
read

	self class read: self.! !

!CtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:09'!
tag

	^ tag! !

!CtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:09'!
tag: aSymbol
	"Tag this attribute. Different tags allows to display this attribute in different ways."

	tag := (self class tags includes: aSymbol) ifTrue: [aSymbol] ifFalse: [].! !

!CtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:10'!
timestamp

	timestamp ifNil: [timestamp := TimeStamp now].
	^ timestamp! !

!CtMarkup methodsFor: 'accessing' stamp: 'mt 1/16/2010 16:10'!
timestamp: aTimeStamp

	timestamp := aTimeStamp.! !

!CtMarkup methodsFor: 'reading' stamp: 'mt 1/16/2010 16:13'!
wasRead

	^ self class wasRead: self! !

Object subclass: #CtMarkupDatabase
	instanceVariableNames: 'classRecords packageRecords'
	classVariableNames: 'Local'
	poolDictionaries: ''
	category: 'CodeTalk-Database'!

!CtMarkupDatabase commentStamp: 'mt 1/16/2010 11:36' prior: 0!
I store markups for packages, classes and methods. Find markups for methods by navigating through the corresponding class container. Due to the lack of namespaces, markups for packages are separately stored. There is no need to encapsulate classes within packages at this level.!

!CtMarkupDatabase class methodsFor: 'local database' stamp: 'mt 1/17/2010 20:52'!
local

	^ Local ifNil: [Local := self new]! !

!CtMarkupDatabase class methodsFor: 'data migration' stamp: 'mt 3/18/2010 19:27'!
mergeFromFileNamed: aFilePath

	| markups |
	[markups := (DataStream fileNamed: aFilePath) next. self local merge: markups]
		on: Error do: [:fallThrough ].! !

!CtMarkupDatabase class methodsFor: 'local database' stamp: 'mt 1/17/2010 20:52'!
resetLocal

	Local := nil.! !

!CtMarkupDatabase methodsFor: 'query - records' stamp: 'mt 1/16/2010 19:42'!
at: aClass

	^ self classRecords
		at: aClass name asSymbol
		ifAbsent: [self classRecords at: aClass name asSymbol put:
				(CtClassRecord newFrom: aClass)]! !

!CtMarkupDatabase methodsFor: 'accessing' stamp: 'mt 1/16/2010 14:58'!
classRecords
	"Key: class name (ByteSymbol)"

	^ classRecords ifNil: [classRecords := Dictionary new]! !

!CtMarkupDatabase methodsFor: 'query - records' stamp: 'mt 1/17/2010 12:56'!
includes: aClass

	^ aClass notNil and: [self classRecords includesKey: aClass name asSymbol]! !

!CtMarkupDatabase methodsFor: 'query - markups' stamp: 'mt 3/19/2010 11:54:51.639'!
markupsForClass: aClass
	"Fetch all markups for the given class and selector in the current version."
	
	| result |
	result := OrderedCollection new.
	(self includes: aClass) ifFalse: [^ result].
	
	aClass selectors do: [:s |
		result addAll: (self
			markupsForClass: aClass
			selector: s)].
		
	aClass isMeta ifFalse: [
		aClass class selectors do: [:s |
			result addAll: (self
			markupsForClass: aClass
			selector: s)]].
	
	^ result! !

!CtMarkupDatabase methodsFor: 'query - markups' stamp: 'mt 3/19/2010 11:53:24.085'!
markupsForClass: aClass selector: aSelector
	"Fetch all markups for the given class and selector in the current version."
	
	^ [self
		markupsForClass: aClass
		selector: aSelector
		version: (aClass >> aSelector) timeStamp]
	on: Error
	do: [:error | #()]! !

!CtMarkupDatabase methodsFor: 'query - markups' stamp: 'mt 1/17/2010 10:53'!
markupsForClass: aClass selector: aSelector version: aTimeStamp
	"Query for markups. Use #includes: and #at: together to avoid filling the database with empty records."

	(self includes: aClass) ifTrue: [| classRecord |
		classRecord := self at: aClass.
		(classRecord includes: aSelector) ifTrue: [
			^ (classRecord at: aSelector) atTimeStamp: aTimeStamp]].
	
	^ #()! !

!CtMarkupDatabase methodsFor: 'query - markups' stamp: 'mt 1/17/2010 14:44'!
markupsForCompiledMethod: aCompiledMethod
	
	aCompiledMethod
		ifNil: [^ #()].
	
	aCompiledMethod methodReference
		ifNil: [Transcript show: '[CodeTalk] Warning!! Compiled method has no information about class or selector!!'; cr].
	
	^ self
		markupsForClass: aCompiledMethod methodClass
		selector: aCompiledMethod selector
		version: aCompiledMethod timeStamp! !

!CtMarkupDatabase methodsFor: 'query - markups' stamp: 'mt 1/17/2010 11:14'!
markupsForMethodReference: aMethodReference
	
	^ self
		markupsForClass: aMethodReference actualClass
		selector: aMethodReference methodSymbol! !

!CtMarkupDatabase methodsFor: 'versioning' stamp: 'mt 1/22/2010 13:37:19'!
merge: aSnapshot
	"Reintegrate a versioned snapshot into this database."
	
	aSnapshot ifNil: [^ self].
	
	[
		aSnapshot classRecords do: [:classRecord |
			classRecord methodRecords do: [:methodRecord |
				methodRecord markups keysAndValuesDo: [:seconds :markups |
					((self at: classRecord theClass)
						at: methodRecord selector)
							markups at: seconds put: markups]]]
	] on: Error do: [:fallThrough |].! !

!CtMarkupDatabase methodsFor: 'accessing' stamp: 'mt 1/16/2010 14:57'!
packageRecords
	"Key: package name (ByteSymbol)"

	^ packageRecords ifNil: [packageRecords := Dictionary new]! !

!CtMarkupDatabase methodsFor: 'versioning' stamp: 'mt 1/17/2010 21:23'!
snapshot: aPackageName
	"Return a subset of this database that contains only MC-versioned records and new working copy records. All records related only to local versions are skipped. MC-Package specific."
	
	| info snapshot |
	info := PackageInfo named: aPackageName.
	snapshot := CtMarkupDatabase new.
	info methods
		do: [:methodRef | | markups |
			markups := self markupsForMethodReference: methodRef.
			markups ifNotEmpty: [
				(((snapshot at: methodRef actualClass) at: methodRef methodSymbol)
					at: (methodRef actualClass >> methodRef methodSymbol)) addAll: markups]]
		displayingProgress: 'Snapshotting markups...'.
	^ snapshot! !

Object subclass: #CtMethodRecord
	instanceVariableNames: 'selector markups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Database'!

!CtMethodRecord commentStamp: 'mt 1/16/2010 11:43' prior: 0!
I am a container for versioned method markups. Normally, I am stored inside a class record.!

!CtMethodRecord class methodsFor: 'instance creation' stamp: 'mt 1/16/2010 12:15'!
newFrom: aCompiledMethod

	^ self new
		selector: aCompiledMethod selector! !

!CtMethodRecord methodsFor: 'query - markups' stamp: 'mt 1/18/2010 09:13'!
addVersion: anInteger

	| container |
	container := self markups
		ifEmpty: [OrderedCollection new]
		ifNotEmpty: [| latestVersion |
			latestVersion := self markups keysSortedSafely last.
			latestVersion < anInteger
				ifTrue: [self markups at: latestVersion]
				ifFalse: [OrderedCollection new]].

	^ self markups
		at: anInteger
		put: container.! !

!CtMethodRecord methodsFor: 'query - markups' stamp: 'mt 1/16/2010 15:19'!
at: aCompiledMethod

	^ self atTimeStamp: aCompiledMethod timeStamp! !

!CtMethodRecord methodsFor: 'query - markups' stamp: 'mt 1/16/2010 15:56'!
atSeconds: anInteger

	^ self markups
		at: anInteger
		ifAbsent: [self addVersion: anInteger]! !

!CtMethodRecord methodsFor: 'query - markups' stamp: 'mt 3/25/2010 13:10:09.949'!
atTimeStamp: aString
	"Expect the following pattern: 'authorinitials 1/16/2010 12:33'"

	^ aString
		ifEmpty: [^ #()]
		ifNotEmpty: [self atSeconds:
			(TimeStamp fromMethodTimeStamp: aString) asSeconds].
	! !

!CtMethodRecord methodsFor: 'query - markups' stamp: 'mt 1/17/2010 19:25'!
clearLastVersion

	self markups
		at: self markups keysSortedSafely last
		put: OrderedCollection new! !

!CtMethodRecord methodsFor: 'query - markups' stamp: 'mt 1/17/2010 18:16'!
copyLastVersion
	"To be used for copy-on-write. Does nothing if the last version is already unique."

	| sourceAndTargetIndices |
	self markups size < 2
		ifTrue: [^ Dictionary new].
	
	sourceAndTargetIndices := self markups keysSortedSafely last: 2.
	(self markups at: sourceAndTargetIndices first) = (self markups at: sourceAndTargetIndices second)
		ifTrue: [|copy|
			copy := Dictionary new.
			(self markups at: sourceAndTargetIndices first) do: [:markup |
				copy at: markup put: markup clone].
			self markups at: sourceAndTargetIndices second put: copy values asOrderedCollection.
			^ copy].
		
	^ Dictionary new! !

!CtMethodRecord methodsFor: 'query - markups' stamp: 'mt 1/17/2010 14:51'!
lastVersion

	self markups ifEmpty: [^ #()].
	^ self markups at: self markups keysSortedSafely last! !

!CtMethodRecord methodsFor: 'accessing' stamp: 'mt 1/16/2010 12:43'!
markups
	"Key: seconds (see TimeStamp class>>fromSeconds:), Value: markups"

	^ markups ifNil: [markups := Dictionary new]! !

!CtMethodRecord methodsFor: 'accessing' stamp: 'mt 1/16/2010 11:59'!
selector

	^ selector! !

!CtMethodRecord methodsFor: 'accessing' stamp: 'mt 1/16/2010 11:59'!
selector: anObject

	selector := anObject.! !

Object subclass: #CtPackageRecord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Database'!

!CtPackageRecord commentStamp: 'mt 1/16/2010 11:45' prior: 0!
I am a container for package markups.!

Object subclass: #CtSourceTextStyler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeTalk-Kernel'!

!CtSourceTextStyler commentStamp: 'mt 1/17/2010 12:29' prior: 0!
I can be used by the SwaSourceTextStyler.!

!CtSourceTextStyler methodsFor: 'styling' stamp: 'mt 5/2/2010 10:49:44.753'!
styleSource: aText markup: aMarkup inClass: aClass selector: aSelector

	| ref bg |
	ref := CtReferenceAttribute forMarkup: aMarkup.
	ref theClass: aClass; selector: aSelector. "Needed for later database lookup."
		
	aText
		addAttribute: ref
		from: aMarkup range first
		to: aMarkup range last
		guarded: true.

	aText
		addAttribute: (CtIconBarAttribute forReference: ref)
		from: aMarkup range first
		to: aMarkup range last
		guarded: true.

	bg := CtTextBackgroundColor color: aMarkup color.
	aText
		addAttribute: bg
		from: aMarkup range first
		to: aMarkup range last
		guarded: true..
	ref addFriend: bg.! !

!CtSourceTextStyler methodsFor: 'styling' stamp: 'mt 1/17/2010 16:05'!
styleSource: aText markups: someMarkups inClass: aClass selector: aSelector

	someMarkups do: [:markup |
		self
			styleSource: aText
			markup: markup
			inClass: aClass
			selector: aSelector]! !

!CtSourceTextStyler methodsFor: 'styling' stamp: 'mt 5/2/2010 10:50:09.752'!
styleSource: aText of: aCompiledMethod
	"This approach does only work for the current version of a method."

	aCompiledMethod ifNil: [^ aText].
	
	self
		styleSource: aText
		markups: (CtMarkupDatabase local markupsForCompiledMethod: aCompiledMethod)
		inClass: aCompiledMethod methodClass
		selector: aCompiledMethod selector.
		
	^ aText! !
CtLoader initialize!
